// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from novatel_gps_msgs:msg/ClockSteering.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__CLOCK_STEERING__STRUCT_H_
#define NOVATEL_GPS_MSGS__MSG__CLOCK_STEERING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'INTERNAL_SOURCE'.
enum
{
  novatel_gps_msgs__msg__ClockSteering__INTERNAL_SOURCE = 0
};

/// Constant 'EXTERNAL_SOURCE'.
enum
{
  novatel_gps_msgs__msg__ClockSteering__EXTERNAL_SOURCE = 1
};

/// Constant 'FIRST_ORDER_STEERING_STATE'.
enum
{
  novatel_gps_msgs__msg__ClockSteering__FIRST_ORDER_STEERING_STATE = 0
};

/// Constant 'SECOND_ORDER_STEERING_STATE'.
enum
{
  novatel_gps_msgs__msg__ClockSteering__SECOND_ORDER_STEERING_STATE = 1
};

/// Constant 'CALIBRATE_HIGH_STEERING_STATE'.
enum
{
  novatel_gps_msgs__msg__ClockSteering__CALIBRATE_HIGH_STEERING_STATE = 2
};

/// Constant 'CALIBRATE_LOW_STEERING_STATE'.
enum
{
  novatel_gps_msgs__msg__ClockSteering__CALIBRATE_LOW_STEERING_STATE = 3
};

/// Constant 'CALIBRATE_CENTER_STEERING_STATE'.
enum
{
  novatel_gps_msgs__msg__ClockSteering__CALIBRATE_CENTER_STEERING_STATE = 4
};

// Include directives for member types
// Member 'source'
// Member 'steering_state'
#include "rosidl_generator_c/string.h"

// Struct defined in msg/ClockSteering in the package novatel_gps_msgs.
typedef struct novatel_gps_msgs__msg__ClockSteering
{
  rosidl_generator_c__String source;
  rosidl_generator_c__String steering_state;
  uint32_t period;
  double pulse_width;
  double bandwidth;
  float slope;
  double offset;
  double drift_rate;
} novatel_gps_msgs__msg__ClockSteering;

// Struct for a sequence of novatel_gps_msgs__msg__ClockSteering.
typedef struct novatel_gps_msgs__msg__ClockSteering__Sequence
{
  novatel_gps_msgs__msg__ClockSteering * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} novatel_gps_msgs__msg__ClockSteering__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NOVATEL_GPS_MSGS__MSG__CLOCK_STEERING__STRUCT_H_
