#ifndef _H_0C8E373DBE403813C18FD1A5566A32D7_ClockSteering__H_
#define _H_0C8E373DBE403813C18FD1A5566A32D7_ClockSteering__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ClockSteering_Constants
            {
                const ::DDS::Octet INTERNAL_SOURCE_ = 0;

                const ::DDS::Octet EXTERNAL_SOURCE_ = 1;

                const ::DDS::Octet FIRST_ORDER_STEERING_STATE_ = 0;

                const ::DDS::Octet SECOND_ORDER_STEERING_STATE_ = 1;

                const ::DDS::Octet CALIBRATE_HIGH_STEERING_STATE_ = 2;

                const ::DDS::Octet CALIBRATE_LOW_STEERING_STATE_ = 3;

                const ::DDS::Octet CALIBRATE_CENTER_STEERING_STATE_ = 4;

            }

            struct  ClockSteering_
            {
                ::DDS::String_mgr source_;
                ::DDS::String_mgr steering_state_;
                ::DDS::ULong period_;
                ::DDS::Double pulse_width_;
                ::DDS::Double bandwidth_;
                ::DDS::Float slope_;
                ::DDS::Double offset_;
                ::DDS::Double drift_rate_;
            };

            typedef DDS_DCPSStruct_var<ClockSteering_> ClockSteering__var;
            typedef DDS_DCPSStruct_out < ClockSteering_> ClockSteering__out;

        }

    }

}

#endif /* _H_0C8E373DBE403813C18FD1A5566A32D7_ClockSteering__H_ */
