#ifndef _H_0C8E373DBE403813C18FD1A5566A32D7_ClockSteering_DCPS_H_
#define _H_0C8E373DBE403813C18FD1A5566A32D7_ClockSteering_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ClockSteering_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ClockSteering_TypeSupportInterface;

            typedef ClockSteering_TypeSupportInterface * ClockSteering_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ClockSteering_TypeSupportInterface> ClockSteering_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ClockSteering_TypeSupportInterface> ClockSteering_TypeSupportInterface_out;


            class ClockSteering_DataWriter;

            typedef ClockSteering_DataWriter * ClockSteering_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ClockSteering_DataWriter> ClockSteering_DataWriter_var;
            typedef DDS_DCPSInterface_out < ClockSteering_DataWriter> ClockSteering_DataWriter_out;


            class ClockSteering_DataReader;

            typedef ClockSteering_DataReader * ClockSteering_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ClockSteering_DataReader> ClockSteering_DataReader_var;
            typedef DDS_DCPSInterface_out < ClockSteering_DataReader> ClockSteering_DataReader_out;


            class ClockSteering_DataReaderView;

            typedef ClockSteering_DataReaderView * ClockSteering_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ClockSteering_DataReaderView> ClockSteering_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ClockSteering_DataReaderView> ClockSteering_DataReaderView_out;

            struct ClockSteering_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ClockSteering_, struct ClockSteering_Seq_uniq_> ClockSteering_Seq;
            typedef DDS_DCPSSequence_var < ClockSteering_Seq> ClockSteering_Seq_var;
            typedef DDS_DCPSSequence_out < ClockSteering_Seq> ClockSteering_Seq_out;

            class  ClockSteering_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ClockSteering_TypeSupportInterface_ptr _ptr_type;
                typedef ClockSteering_TypeSupportInterface_var _var_type;

                static ClockSteering_TypeSupportInterface_ptr _duplicate (ClockSteering_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClockSteering_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ClockSteering_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClockSteering_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ClockSteering_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ClockSteering_TypeSupportInterface () {};
                ~ClockSteering_TypeSupportInterface () {};
            private:
                ClockSteering_TypeSupportInterface (const ClockSteering_TypeSupportInterface &);
                ClockSteering_TypeSupportInterface & operator = (const ClockSteering_TypeSupportInterface &);
            };

            class  ClockSteering_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ClockSteering_DataWriter_ptr _ptr_type;
                typedef ClockSteering_DataWriter_var _var_type;

                static ClockSteering_DataWriter_ptr _duplicate (ClockSteering_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClockSteering_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ClockSteering_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClockSteering_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ClockSteering_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ClockSteering_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ClockSteering_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ClockSteering_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ClockSteering_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ClockSteering_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ClockSteering_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ClockSteering_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ClockSteering_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ClockSteering_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ClockSteering_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ClockSteering_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClockSteering_& instance_data) = 0;

            protected:
                ClockSteering_DataWriter () {};
                ~ClockSteering_DataWriter () {};
            private:
                ClockSteering_DataWriter (const ClockSteering_DataWriter &);
                ClockSteering_DataWriter & operator = (const ClockSteering_DataWriter &);
            };

            class  ClockSteering_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ClockSteering_DataReader_ptr _ptr_type;
                typedef ClockSteering_DataReader_var _var_type;

                static ClockSteering_DataReader_ptr _duplicate (ClockSteering_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClockSteering_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ClockSteering_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClockSteering_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ClockSteering_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClockSteering_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClockSteering_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClockSteering_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClockSteering_& instance) = 0;

            protected:
                ClockSteering_DataReader () {};
                ~ClockSteering_DataReader () {};
            private:
                ClockSteering_DataReader (const ClockSteering_DataReader &);
                ClockSteering_DataReader & operator = (const ClockSteering_DataReader &);
            };

            class  ClockSteering_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ClockSteering_DataReaderView_ptr _ptr_type;
                typedef ClockSteering_DataReaderView_var _var_type;

                static ClockSteering_DataReaderView_ptr _duplicate (ClockSteering_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClockSteering_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ClockSteering_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClockSteering_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ClockSteering_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClockSteering_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClockSteering_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClockSteering_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClockSteering_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClockSteering_& instance) = 0;

            protected:
                ClockSteering_DataReaderView () {};
                ~ClockSteering_DataReaderView () {};
            private:
                ClockSteering_DataReaderView (const ClockSteering_DataReaderView &);
                ClockSteering_DataReaderView & operator = (const ClockSteering_DataReaderView &);
            };
        }

    }

}

#endif
