#ifndef _H_FEBD0A212E752E733C0E46D68AAEDDCB_Gprmc_DCPS_H_
#define _H_FEBD0A212E752E733C0E46D68AAEDDCB_Gprmc_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Gprmc_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Gprmc_TypeSupportInterface;

            typedef Gprmc_TypeSupportInterface * Gprmc_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Gprmc_TypeSupportInterface> Gprmc_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Gprmc_TypeSupportInterface> Gprmc_TypeSupportInterface_out;


            class Gprmc_DataWriter;

            typedef Gprmc_DataWriter * Gprmc_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Gprmc_DataWriter> Gprmc_DataWriter_var;
            typedef DDS_DCPSInterface_out < Gprmc_DataWriter> Gprmc_DataWriter_out;


            class Gprmc_DataReader;

            typedef Gprmc_DataReader * Gprmc_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Gprmc_DataReader> Gprmc_DataReader_var;
            typedef DDS_DCPSInterface_out < Gprmc_DataReader> Gprmc_DataReader_out;


            class Gprmc_DataReaderView;

            typedef Gprmc_DataReaderView * Gprmc_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Gprmc_DataReaderView> Gprmc_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Gprmc_DataReaderView> Gprmc_DataReaderView_out;

            struct Gprmc_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Gprmc_, struct Gprmc_Seq_uniq_> Gprmc_Seq;
            typedef DDS_DCPSSequence_var < Gprmc_Seq> Gprmc_Seq_var;
            typedef DDS_DCPSSequence_out < Gprmc_Seq> Gprmc_Seq_out;

            class  Gprmc_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Gprmc_TypeSupportInterface_ptr _ptr_type;
                typedef Gprmc_TypeSupportInterface_var _var_type;

                static Gprmc_TypeSupportInterface_ptr _duplicate (Gprmc_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gprmc_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Gprmc_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gprmc_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Gprmc_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Gprmc_TypeSupportInterface () {};
                ~Gprmc_TypeSupportInterface () {};
            private:
                Gprmc_TypeSupportInterface (const Gprmc_TypeSupportInterface &);
                Gprmc_TypeSupportInterface & operator = (const Gprmc_TypeSupportInterface &);
            };

            class  Gprmc_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Gprmc_DataWriter_ptr _ptr_type;
                typedef Gprmc_DataWriter_var _var_type;

                static Gprmc_DataWriter_ptr _duplicate (Gprmc_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gprmc_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Gprmc_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gprmc_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Gprmc_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Gprmc_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Gprmc_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Gprmc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Gprmc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Gprmc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Gprmc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Gprmc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Gprmc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Gprmc_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Gprmc_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Gprmc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gprmc_& instance_data) = 0;

            protected:
                Gprmc_DataWriter () {};
                ~Gprmc_DataWriter () {};
            private:
                Gprmc_DataWriter (const Gprmc_DataWriter &);
                Gprmc_DataWriter & operator = (const Gprmc_DataWriter &);
            };

            class  Gprmc_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Gprmc_DataReader_ptr _ptr_type;
                typedef Gprmc_DataReader_var _var_type;

                static Gprmc_DataReader_ptr _duplicate (Gprmc_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gprmc_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Gprmc_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gprmc_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Gprmc_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gprmc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gprmc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gprmc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gprmc_& instance) = 0;

            protected:
                Gprmc_DataReader () {};
                ~Gprmc_DataReader () {};
            private:
                Gprmc_DataReader (const Gprmc_DataReader &);
                Gprmc_DataReader & operator = (const Gprmc_DataReader &);
            };

            class  Gprmc_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Gprmc_DataReaderView_ptr _ptr_type;
                typedef Gprmc_DataReaderView_var _var_type;

                static Gprmc_DataReaderView_ptr _duplicate (Gprmc_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gprmc_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Gprmc_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gprmc_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Gprmc_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gprmc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gprmc_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gprmc_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gprmc_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gprmc_& instance) = 0;

            protected:
                Gprmc_DataReaderView () {};
                ~Gprmc_DataReaderView () {};
            private:
                Gprmc_DataReaderView (const Gprmc_DataReaderView &);
                Gprmc_DataReaderView & operator = (const Gprmc_DataReaderView &);
            };
        }

    }

}

#endif
