#ifndef _H_3D8DCF07AAFBBA9216270852AF2F1AD3_Inscov__H_
#define _H_3D8DCF07AAFBBA9216270852AF2F1AD3_Inscov__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Inscov_
            {
                struct _position_covariance__uniq_{};
                typedef ::DDS::Double _position_covariance__slice;
                typedef ::DDS::Double _position_covariance_[9];
                typedef DDS_DCPS_FArray_var< _position_covariance_, _position_covariance__slice, struct _position_covariance__uniq_ > _position_covariance__var;
                typedef _position_covariance_ _position_covariance__out;
                typedef DDS_DCPS_Array_forany< _position_covariance_, _position_covariance__slice, struct _position_covariance__uniq_ > _position_covariance__forany;
                static _position_covariance__slice *_position_covariance__alloc();
                static void _position_covariance__free(_position_covariance__slice *);
                static void _position_covariance__copy(_position_covariance__slice *to, const _position_covariance__slice *from);
                static _position_covariance__slice *_position_covariance__dup(const _position_covariance__slice *from);
                struct _attitude_covariance__uniq_{};
                typedef ::DDS::Double _attitude_covariance__slice;
                typedef ::DDS::Double _attitude_covariance_[9];
                typedef DDS_DCPS_FArray_var< _attitude_covariance_, _attitude_covariance__slice, struct _attitude_covariance__uniq_ > _attitude_covariance__var;
                typedef _attitude_covariance_ _attitude_covariance__out;
                typedef DDS_DCPS_Array_forany< _attitude_covariance_, _attitude_covariance__slice, struct _attitude_covariance__uniq_ > _attitude_covariance__forany;
                static _attitude_covariance__slice *_attitude_covariance__alloc();
                static void _attitude_covariance__free(_attitude_covariance__slice *);
                static void _attitude_covariance__copy(_attitude_covariance__slice *to, const _attitude_covariance__slice *from);
                static _attitude_covariance__slice *_attitude_covariance__dup(const _attitude_covariance__slice *from);
                struct _velocity_covariance__uniq_{};
                typedef ::DDS::Double _velocity_covariance__slice;
                typedef ::DDS::Double _velocity_covariance_[9];
                typedef DDS_DCPS_FArray_var< _velocity_covariance_, _velocity_covariance__slice, struct _velocity_covariance__uniq_ > _velocity_covariance__var;
                typedef _velocity_covariance_ _velocity_covariance__out;
                typedef DDS_DCPS_Array_forany< _velocity_covariance_, _velocity_covariance__slice, struct _velocity_covariance__uniq_ > _velocity_covariance__forany;
                static _velocity_covariance__slice *_velocity_covariance__alloc();
                static void _velocity_covariance__free(_velocity_covariance__slice *);
                static void _velocity_covariance__copy(_velocity_covariance__slice *to, const _velocity_covariance__slice *from);
                static _velocity_covariance__slice *_velocity_covariance__dup(const _velocity_covariance__slice *from);
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::ULong week_;
                ::DDS::Double seconds_;
                _position_covariance_ position_covariance_;
                _attitude_covariance_ attitude_covariance_;
                _velocity_covariance_ velocity_covariance_;
            };

            typedef DDS_DCPSStruct_var<Inscov_> Inscov__var;
            typedef DDS_DCPSStruct_out < Inscov_> Inscov__out;

        }

    }

}

#endif /* _H_3D8DCF07AAFBBA9216270852AF2F1AD3_Inscov__H_ */
