#ifndef _H_3D8DCF07AAFBBA9216270852AF2F1AD3_Inscov_DCPS_H_
#define _H_3D8DCF07AAFBBA9216270852AF2F1AD3_Inscov_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Inscov_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Inscov_TypeSupportInterface;

            typedef Inscov_TypeSupportInterface * Inscov_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Inscov_TypeSupportInterface> Inscov_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Inscov_TypeSupportInterface> Inscov_TypeSupportInterface_out;


            class Inscov_DataWriter;

            typedef Inscov_DataWriter * Inscov_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Inscov_DataWriter> Inscov_DataWriter_var;
            typedef DDS_DCPSInterface_out < Inscov_DataWriter> Inscov_DataWriter_out;


            class Inscov_DataReader;

            typedef Inscov_DataReader * Inscov_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Inscov_DataReader> Inscov_DataReader_var;
            typedef DDS_DCPSInterface_out < Inscov_DataReader> Inscov_DataReader_out;


            class Inscov_DataReaderView;

            typedef Inscov_DataReaderView * Inscov_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Inscov_DataReaderView> Inscov_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Inscov_DataReaderView> Inscov_DataReaderView_out;

            struct Inscov_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Inscov_, struct Inscov_Seq_uniq_> Inscov_Seq;
            typedef DDS_DCPSSequence_var < Inscov_Seq> Inscov_Seq_var;
            typedef DDS_DCPSSequence_out < Inscov_Seq> Inscov_Seq_out;

            class  Inscov_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Inscov_TypeSupportInterface_ptr _ptr_type;
                typedef Inscov_TypeSupportInterface_var _var_type;

                static Inscov_TypeSupportInterface_ptr _duplicate (Inscov_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inscov_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Inscov_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inscov_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Inscov_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Inscov_TypeSupportInterface () {};
                ~Inscov_TypeSupportInterface () {};
            private:
                Inscov_TypeSupportInterface (const Inscov_TypeSupportInterface &);
                Inscov_TypeSupportInterface & operator = (const Inscov_TypeSupportInterface &);
            };

            class  Inscov_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Inscov_DataWriter_ptr _ptr_type;
                typedef Inscov_DataWriter_var _var_type;

                static Inscov_DataWriter_ptr _duplicate (Inscov_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inscov_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Inscov_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inscov_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Inscov_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Inscov_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Inscov_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Inscov_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Inscov_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Inscov_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Inscov_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Inscov_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Inscov_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Inscov_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Inscov_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Inscov_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inscov_& instance_data) = 0;

            protected:
                Inscov_DataWriter () {};
                ~Inscov_DataWriter () {};
            private:
                Inscov_DataWriter (const Inscov_DataWriter &);
                Inscov_DataWriter & operator = (const Inscov_DataWriter &);
            };

            class  Inscov_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Inscov_DataReader_ptr _ptr_type;
                typedef Inscov_DataReader_var _var_type;

                static Inscov_DataReader_ptr _duplicate (Inscov_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inscov_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Inscov_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inscov_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Inscov_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Inscov_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Inscov_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Inscov_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inscov_& instance) = 0;

            protected:
                Inscov_DataReader () {};
                ~Inscov_DataReader () {};
            private:
                Inscov_DataReader (const Inscov_DataReader &);
                Inscov_DataReader & operator = (const Inscov_DataReader &);
            };

            class  Inscov_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Inscov_DataReaderView_ptr _ptr_type;
                typedef Inscov_DataReaderView_var _var_type;

                static Inscov_DataReaderView_ptr _duplicate (Inscov_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inscov_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Inscov_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inscov_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Inscov_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Inscov_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Inscov_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Inscov_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Inscov_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inscov_& instance) = 0;

            protected:
                Inscov_DataReaderView () {};
                ~Inscov_DataReaderView () {};
            private:
                Inscov_DataReaderView (const Inscov_DataReaderView &);
                Inscov_DataReaderView & operator = (const Inscov_DataReaderView &);
            };
        }

    }

}

#endif
