#ifndef _H_D48BAD9597CA82038872148EEEBFD928_Inspvax__H_
#define _H_D48BAD9597CA82038872148EEEBFD928_Inspvax__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelExtendedSolutionStatus_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Inspvax_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::String_mgr ins_status_;
                ::DDS::String_mgr position_type_;
                ::DDS::Double latitude_;
                ::DDS::Double longitude_;
                ::DDS::Double altitude_;
                ::DDS::Float undulation_;
                ::DDS::Double north_velocity_;
                ::DDS::Double east_velocity_;
                ::DDS::Double up_velocity_;
                ::DDS::Double roll_;
                ::DDS::Double pitch_;
                ::DDS::Double azimuth_;
                ::DDS::Float latitude_std_;
                ::DDS::Float longitude_std_;
                ::DDS::Float altitude_std_;
                ::DDS::Float north_velocity_std_;
                ::DDS::Float east_velocity_std_;
                ::DDS::Float up_velocity_std_;
                ::DDS::Float roll_std_;
                ::DDS::Float pitch_std_;
                ::DDS::Float azimuth_std_;
                ::novatel_gps_msgs::msg::dds_::NovatelExtendedSolutionStatus_ extended_status_;
                ::DDS::UShort seconds_since_update_;
            };

            typedef DDS_DCPSStruct_var<Inspvax_> Inspvax__var;
            typedef DDS_DCPSStruct_out < Inspvax_> Inspvax__out;

        }

    }

}

#endif /* _H_D48BAD9597CA82038872148EEEBFD928_Inspvax__H_ */
