#ifndef _H_BC4D5E0F5C973E7C59A2F37AB7414725_NovatelDualAntennaHeading__H_
#define _H_BC4D5E0F5C973E7C59A2F37AB7414725_NovatelDualAntennaHeading__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelExtendedSolutionStatus_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelSignalMask_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace NovatelDualAntennaHeading_Constants
            {
                const ::DDS::Octet SOURCE_PRIMARY_ANTENNA_ = 0;

                const ::DDS::Octet SOURCE_SECONDARY_ANTENNA_ = 1;

            }

            struct  NovatelDualAntennaHeading_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::String_mgr solution_status_;
                ::DDS::String_mgr position_type_;
                ::DDS::Float baseline_length_;
                ::DDS::Float heading_;
                ::DDS::Float pitch_;
                ::DDS::Float heading_sigma_;
                ::DDS::Float pitch_sigma_;
                ::DDS::String_mgr station_id_;
                ::DDS::Octet num_satellites_tracked_;
                ::DDS::Octet num_satellites_used_in_solution_;
                ::DDS::Octet num_satellites_above_elevation_mask_angle_;
                ::DDS::Octet num_satellites_above_elevation_mask_angle_l2_;
                ::DDS::Octet solution_source_;
                ::novatel_gps_msgs::msg::dds_::NovatelExtendedSolutionStatus_ extended_solution_status_;
                ::novatel_gps_msgs::msg::dds_::NovatelSignalMask_ signal_mask_;
            };

            typedef DDS_DCPSStruct_var<NovatelDualAntennaHeading_> NovatelDualAntennaHeading__var;
            typedef DDS_DCPSStruct_out < NovatelDualAntennaHeading_> NovatelDualAntennaHeading__out;

        }

    }

}

#endif /* _H_BC4D5E0F5C973E7C59A2F37AB7414725_NovatelDualAntennaHeading__H_ */
