#ifndef H_BC4D5E0F5C973E7C59A2F37AB7414725_NovatelDualAntennaHeading_SPLTYPES_H
#define H_BC4D5E0F5C973E7C59A2F37AB7414725_NovatelDualAntennaHeading_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_NovatelDualAntennaHeading_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelExtendedSolutionStatus_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelSignalMask_SplDcps.h"



extern c_metaObject __NovatelDualAntennaHeading__novatel_gps_msgs__load (c_base base);

extern c_metaObject __NovatelDualAntennaHeading__novatel_gps_msgs_msg__load (c_base base);

extern c_metaObject __NovatelDualAntennaHeading__novatel_gps_msgs_msg_dds___load (c_base base);

extern c_metaObject __NovatelDualAntennaHeading__novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading_Constants__load (c_base base);

extern const char *novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading__metaDescriptor[];
extern const int novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading__metaDescriptorArrLength;
extern const int novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading__metaDescriptorLength;
extern c_metaObject __novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading___load (c_base base);
struct _novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading_ ;
extern  v_copyin_result __novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading___copyIn(c_base base, const struct novatel_gps_msgs::msg::dds_::NovatelDualAntennaHeading_ *from, struct _novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading_ *to);
extern  void __novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading___copyOut(const void *_from, void *_to);
struct _novatel_gps_msgs_msg_dds__NovatelDualAntennaHeading_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _novatel_gps_msgs_msg_dds__NovatelMessageHeader_ novatel_msg_header_;
    c_string solution_status_;
    c_string position_type_;
    c_float baseline_length_;
    c_float heading_;
    c_float pitch_;
    c_float heading_sigma_;
    c_float pitch_sigma_;
    c_string station_id_;
    c_octet num_satellites_tracked_;
    c_octet num_satellites_used_in_solution_;
    c_octet num_satellites_above_elevation_mask_angle_;
    c_octet num_satellites_above_elevation_mask_angle_l2_;
    c_octet solution_source_;
    struct _novatel_gps_msgs_msg_dds__NovatelExtendedSolutionStatus_ extended_solution_status_;
    struct _novatel_gps_msgs_msg_dds__NovatelSignalMask_ signal_mask_;
};

#undef OS_API
#endif
