#ifndef _H_445F63A181560654F36E5E18196CA711_NovatelHeading2_DCPS_H_
#define _H_445F63A181560654F36E5E18196CA711_NovatelHeading2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelHeading2_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelHeading2_TypeSupportInterface;

            typedef NovatelHeading2_TypeSupportInterface * NovatelHeading2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelHeading2_TypeSupportInterface> NovatelHeading2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelHeading2_TypeSupportInterface> NovatelHeading2_TypeSupportInterface_out;


            class NovatelHeading2_DataWriter;

            typedef NovatelHeading2_DataWriter * NovatelHeading2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelHeading2_DataWriter> NovatelHeading2_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelHeading2_DataWriter> NovatelHeading2_DataWriter_out;


            class NovatelHeading2_DataReader;

            typedef NovatelHeading2_DataReader * NovatelHeading2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelHeading2_DataReader> NovatelHeading2_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelHeading2_DataReader> NovatelHeading2_DataReader_out;


            class NovatelHeading2_DataReaderView;

            typedef NovatelHeading2_DataReaderView * NovatelHeading2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelHeading2_DataReaderView> NovatelHeading2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelHeading2_DataReaderView> NovatelHeading2_DataReaderView_out;

            struct NovatelHeading2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelHeading2_, struct NovatelHeading2_Seq_uniq_> NovatelHeading2_Seq;
            typedef DDS_DCPSSequence_var < NovatelHeading2_Seq> NovatelHeading2_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelHeading2_Seq> NovatelHeading2_Seq_out;

            class  NovatelHeading2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelHeading2_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelHeading2_TypeSupportInterface_var _var_type;

                static NovatelHeading2_TypeSupportInterface_ptr _duplicate (NovatelHeading2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelHeading2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelHeading2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelHeading2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelHeading2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelHeading2_TypeSupportInterface () {};
                ~NovatelHeading2_TypeSupportInterface () {};
            private:
                NovatelHeading2_TypeSupportInterface (const NovatelHeading2_TypeSupportInterface &);
                NovatelHeading2_TypeSupportInterface & operator = (const NovatelHeading2_TypeSupportInterface &);
            };

            class  NovatelHeading2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelHeading2_DataWriter_ptr _ptr_type;
                typedef NovatelHeading2_DataWriter_var _var_type;

                static NovatelHeading2_DataWriter_ptr _duplicate (NovatelHeading2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelHeading2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelHeading2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelHeading2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelHeading2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelHeading2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelHeading2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelHeading2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelHeading2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelHeading2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelHeading2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelHeading2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelHeading2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelHeading2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelHeading2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelHeading2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelHeading2_& instance_data) = 0;

            protected:
                NovatelHeading2_DataWriter () {};
                ~NovatelHeading2_DataWriter () {};
            private:
                NovatelHeading2_DataWriter (const NovatelHeading2_DataWriter &);
                NovatelHeading2_DataWriter & operator = (const NovatelHeading2_DataWriter &);
            };

            class  NovatelHeading2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelHeading2_DataReader_ptr _ptr_type;
                typedef NovatelHeading2_DataReader_var _var_type;

                static NovatelHeading2_DataReader_ptr _duplicate (NovatelHeading2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelHeading2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelHeading2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelHeading2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelHeading2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelHeading2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelHeading2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelHeading2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelHeading2_& instance) = 0;

            protected:
                NovatelHeading2_DataReader () {};
                ~NovatelHeading2_DataReader () {};
            private:
                NovatelHeading2_DataReader (const NovatelHeading2_DataReader &);
                NovatelHeading2_DataReader & operator = (const NovatelHeading2_DataReader &);
            };

            class  NovatelHeading2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelHeading2_DataReaderView_ptr _ptr_type;
                typedef NovatelHeading2_DataReaderView_var _var_type;

                static NovatelHeading2_DataReaderView_ptr _duplicate (NovatelHeading2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelHeading2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelHeading2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelHeading2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelHeading2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelHeading2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelHeading2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelHeading2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelHeading2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelHeading2_& instance) = 0;

            protected:
                NovatelHeading2_DataReaderView () {};
                ~NovatelHeading2_DataReaderView () {};
            private:
                NovatelHeading2_DataReaderView (const NovatelHeading2_DataReaderView &);
                NovatelHeading2_DataReaderView & operator = (const NovatelHeading2_DataReaderView &);
            };
        }

    }

}

#endif
