#ifndef H_445F63A181560654F36E5E18196CA711_NovatelHeading2_SPLTYPES_H
#define H_445F63A181560654F36E5E18196CA711_NovatelHeading2_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_NovatelHeading2_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelExtendedSolutionStatus_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelSignalMask_SplDcps.h"



extern c_metaObject __NovatelHeading2__novatel_gps_msgs__load (c_base base);

extern c_metaObject __NovatelHeading2__novatel_gps_msgs_msg__load (c_base base);

extern c_metaObject __NovatelHeading2__novatel_gps_msgs_msg_dds___load (c_base base);

extern c_metaObject __NovatelHeading2__novatel_gps_msgs_msg_dds__NovatelHeading2_Constants__load (c_base base);

extern const char *novatel_gps_msgs_msg_dds__NovatelHeading2__metaDescriptor[];
extern const int novatel_gps_msgs_msg_dds__NovatelHeading2__metaDescriptorArrLength;
extern const int novatel_gps_msgs_msg_dds__NovatelHeading2__metaDescriptorLength;
extern c_metaObject __novatel_gps_msgs_msg_dds__NovatelHeading2___load (c_base base);
struct _novatel_gps_msgs_msg_dds__NovatelHeading2_ ;
extern  v_copyin_result __novatel_gps_msgs_msg_dds__NovatelHeading2___copyIn(c_base base, const struct novatel_gps_msgs::msg::dds_::NovatelHeading2_ *from, struct _novatel_gps_msgs_msg_dds__NovatelHeading2_ *to);
extern  void __novatel_gps_msgs_msg_dds__NovatelHeading2___copyOut(const void *_from, void *_to);
struct _novatel_gps_msgs_msg_dds__NovatelHeading2_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _novatel_gps_msgs_msg_dds__NovatelMessageHeader_ novatel_msg_header_;
    c_string solution_status_;
    c_string position_type_;
    c_float baseline_length_;
    c_float heading_;
    c_float pitch_;
    c_float heading_sigma_;
    c_float pitch_sigma_;
    c_string rover_station_id_;
    c_string master_station_id_;
    c_octet num_satellites_tracked_;
    c_octet num_satellites_used_in_solution_;
    c_octet num_satellites_above_elevation_mask_angle_;
    c_octet num_satellites_above_elevation_mask_angle_l2_;
    c_octet solution_source_;
    struct _novatel_gps_msgs_msg_dds__NovatelExtendedSolutionStatus_ extended_solution_status_;
    struct _novatel_gps_msgs_msg_dds__NovatelSignalMask_ signal_mask_;
};

#undef OS_API
#endif
