#ifndef _H_830CC9471A868B8F1317F6FB0C746020_NovatelPosition_DCPS_H_
#define _H_830CC9471A868B8F1317F6FB0C746020_NovatelPosition_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelPosition_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelPosition_TypeSupportInterface;

            typedef NovatelPosition_TypeSupportInterface * NovatelPosition_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelPosition_TypeSupportInterface> NovatelPosition_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelPosition_TypeSupportInterface> NovatelPosition_TypeSupportInterface_out;


            class NovatelPosition_DataWriter;

            typedef NovatelPosition_DataWriter * NovatelPosition_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelPosition_DataWriter> NovatelPosition_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelPosition_DataWriter> NovatelPosition_DataWriter_out;


            class NovatelPosition_DataReader;

            typedef NovatelPosition_DataReader * NovatelPosition_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelPosition_DataReader> NovatelPosition_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelPosition_DataReader> NovatelPosition_DataReader_out;


            class NovatelPosition_DataReaderView;

            typedef NovatelPosition_DataReaderView * NovatelPosition_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelPosition_DataReaderView> NovatelPosition_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelPosition_DataReaderView> NovatelPosition_DataReaderView_out;

            struct NovatelPosition_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelPosition_, struct NovatelPosition_Seq_uniq_> NovatelPosition_Seq;
            typedef DDS_DCPSSequence_var < NovatelPosition_Seq> NovatelPosition_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelPosition_Seq> NovatelPosition_Seq_out;

            class  NovatelPosition_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelPosition_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelPosition_TypeSupportInterface_var _var_type;

                static NovatelPosition_TypeSupportInterface_ptr _duplicate (NovatelPosition_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPosition_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPosition_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPosition_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPosition_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelPosition_TypeSupportInterface () {};
                ~NovatelPosition_TypeSupportInterface () {};
            private:
                NovatelPosition_TypeSupportInterface (const NovatelPosition_TypeSupportInterface &);
                NovatelPosition_TypeSupportInterface & operator = (const NovatelPosition_TypeSupportInterface &);
            };

            class  NovatelPosition_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelPosition_DataWriter_ptr _ptr_type;
                typedef NovatelPosition_DataWriter_var _var_type;

                static NovatelPosition_DataWriter_ptr _duplicate (NovatelPosition_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPosition_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPosition_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPosition_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPosition_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelPosition_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelPosition_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPosition_& instance_data) = 0;

            protected:
                NovatelPosition_DataWriter () {};
                ~NovatelPosition_DataWriter () {};
            private:
                NovatelPosition_DataWriter (const NovatelPosition_DataWriter &);
                NovatelPosition_DataWriter & operator = (const NovatelPosition_DataWriter &);
            };

            class  NovatelPosition_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelPosition_DataReader_ptr _ptr_type;
                typedef NovatelPosition_DataReader_var _var_type;

                static NovatelPosition_DataReader_ptr _duplicate (NovatelPosition_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPosition_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPosition_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPosition_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPosition_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPosition_& instance) = 0;

            protected:
                NovatelPosition_DataReader () {};
                ~NovatelPosition_DataReader () {};
            private:
                NovatelPosition_DataReader (const NovatelPosition_DataReader &);
                NovatelPosition_DataReader & operator = (const NovatelPosition_DataReader &);
            };

            class  NovatelPosition_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelPosition_DataReaderView_ptr _ptr_type;
                typedef NovatelPosition_DataReaderView_var _var_type;

                static NovatelPosition_DataReaderView_ptr _duplicate (NovatelPosition_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPosition_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPosition_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPosition_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPosition_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPosition_& instance) = 0;

            protected:
                NovatelPosition_DataReaderView () {};
                ~NovatelPosition_DataReaderView () {};
            private:
                NovatelPosition_DataReaderView (const NovatelPosition_DataReaderView &);
                NovatelPosition_DataReaderView & operator = (const NovatelPosition_DataReaderView &);
            };
        }

    }

}

#endif
