#ifndef _H_88DD681588E63DAEB7679D7CE4E51C3B_NovatelPsrdop2System_DCPS_H_
#define _H_88DD681588E63DAEB7679D7CE4E51C3B_NovatelPsrdop2System_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelPsrdop2System_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelPsrdop2System_TypeSupportInterface;

            typedef NovatelPsrdop2System_TypeSupportInterface * NovatelPsrdop2System_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelPsrdop2System_TypeSupportInterface> NovatelPsrdop2System_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelPsrdop2System_TypeSupportInterface> NovatelPsrdop2System_TypeSupportInterface_out;


            class NovatelPsrdop2System_DataWriter;

            typedef NovatelPsrdop2System_DataWriter * NovatelPsrdop2System_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelPsrdop2System_DataWriter> NovatelPsrdop2System_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelPsrdop2System_DataWriter> NovatelPsrdop2System_DataWriter_out;


            class NovatelPsrdop2System_DataReader;

            typedef NovatelPsrdop2System_DataReader * NovatelPsrdop2System_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelPsrdop2System_DataReader> NovatelPsrdop2System_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelPsrdop2System_DataReader> NovatelPsrdop2System_DataReader_out;


            class NovatelPsrdop2System_DataReaderView;

            typedef NovatelPsrdop2System_DataReaderView * NovatelPsrdop2System_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelPsrdop2System_DataReaderView> NovatelPsrdop2System_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelPsrdop2System_DataReaderView> NovatelPsrdop2System_DataReaderView_out;

            struct NovatelPsrdop2System_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelPsrdop2System_, struct NovatelPsrdop2System_Seq_uniq_> NovatelPsrdop2System_Seq;
            typedef DDS_DCPSSequence_var < NovatelPsrdop2System_Seq> NovatelPsrdop2System_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelPsrdop2System_Seq> NovatelPsrdop2System_Seq_out;

            class  NovatelPsrdop2System_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelPsrdop2System_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelPsrdop2System_TypeSupportInterface_var _var_type;

                static NovatelPsrdop2System_TypeSupportInterface_ptr _duplicate (NovatelPsrdop2System_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPsrdop2System_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2System_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2System_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPsrdop2System_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelPsrdop2System_TypeSupportInterface () {};
                ~NovatelPsrdop2System_TypeSupportInterface () {};
            private:
                NovatelPsrdop2System_TypeSupportInterface (const NovatelPsrdop2System_TypeSupportInterface &);
                NovatelPsrdop2System_TypeSupportInterface & operator = (const NovatelPsrdop2System_TypeSupportInterface &);
            };

            class  NovatelPsrdop2System_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelPsrdop2System_DataWriter_ptr _ptr_type;
                typedef NovatelPsrdop2System_DataWriter_var _var_type;

                static NovatelPsrdop2System_DataWriter_ptr _duplicate (NovatelPsrdop2System_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPsrdop2System_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2System_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2System_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPsrdop2System_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelPsrdop2System_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelPsrdop2System_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelPsrdop2System_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelPsrdop2System_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelPsrdop2System_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelPsrdop2System_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelPsrdop2System_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelPsrdop2System_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelPsrdop2System_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelPsrdop2System_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelPsrdop2System_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPsrdop2System_& instance_data) = 0;

            protected:
                NovatelPsrdop2System_DataWriter () {};
                ~NovatelPsrdop2System_DataWriter () {};
            private:
                NovatelPsrdop2System_DataWriter (const NovatelPsrdop2System_DataWriter &);
                NovatelPsrdop2System_DataWriter & operator = (const NovatelPsrdop2System_DataWriter &);
            };

            class  NovatelPsrdop2System_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelPsrdop2System_DataReader_ptr _ptr_type;
                typedef NovatelPsrdop2System_DataReader_var _var_type;

                static NovatelPsrdop2System_DataReader_ptr _duplicate (NovatelPsrdop2System_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPsrdop2System_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2System_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2System_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPsrdop2System_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelPsrdop2System_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelPsrdop2System_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelPsrdop2System_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPsrdop2System_& instance) = 0;

            protected:
                NovatelPsrdop2System_DataReader () {};
                ~NovatelPsrdop2System_DataReader () {};
            private:
                NovatelPsrdop2System_DataReader (const NovatelPsrdop2System_DataReader &);
                NovatelPsrdop2System_DataReader & operator = (const NovatelPsrdop2System_DataReader &);
            };

            class  NovatelPsrdop2System_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelPsrdop2System_DataReaderView_ptr _ptr_type;
                typedef NovatelPsrdop2System_DataReaderView_var _var_type;

                static NovatelPsrdop2System_DataReaderView_ptr _duplicate (NovatelPsrdop2System_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPsrdop2System_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2System_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2System_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPsrdop2System_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelPsrdop2System_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelPsrdop2System_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelPsrdop2System_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelPsrdop2System_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPsrdop2System_& instance) = 0;

            protected:
                NovatelPsrdop2System_DataReaderView () {};
                ~NovatelPsrdop2System_DataReaderView () {};
            private:
                NovatelPsrdop2System_DataReaderView (const NovatelPsrdop2System_DataReaderView &);
                NovatelPsrdop2System_DataReaderView & operator = (const NovatelPsrdop2System_DataReaderView &);
            };
        }

    }

}

#endif
