#ifndef _H_365229D7CDDED3403F836446AE98777E_NovatelPsrdop2_DCPS_H_
#define _H_365229D7CDDED3403F836446AE98777E_NovatelPsrdop2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelPsrdop2_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelPsrdop2_TypeSupportInterface;

            typedef NovatelPsrdop2_TypeSupportInterface * NovatelPsrdop2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelPsrdop2_TypeSupportInterface> NovatelPsrdop2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelPsrdop2_TypeSupportInterface> NovatelPsrdop2_TypeSupportInterface_out;


            class NovatelPsrdop2_DataWriter;

            typedef NovatelPsrdop2_DataWriter * NovatelPsrdop2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelPsrdop2_DataWriter> NovatelPsrdop2_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelPsrdop2_DataWriter> NovatelPsrdop2_DataWriter_out;


            class NovatelPsrdop2_DataReader;

            typedef NovatelPsrdop2_DataReader * NovatelPsrdop2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelPsrdop2_DataReader> NovatelPsrdop2_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelPsrdop2_DataReader> NovatelPsrdop2_DataReader_out;


            class NovatelPsrdop2_DataReaderView;

            typedef NovatelPsrdop2_DataReaderView * NovatelPsrdop2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelPsrdop2_DataReaderView> NovatelPsrdop2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelPsrdop2_DataReaderView> NovatelPsrdop2_DataReaderView_out;

            struct NovatelPsrdop2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelPsrdop2_, struct NovatelPsrdop2_Seq_uniq_> NovatelPsrdop2_Seq;
            typedef DDS_DCPSSequence_var < NovatelPsrdop2_Seq> NovatelPsrdop2_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelPsrdop2_Seq> NovatelPsrdop2_Seq_out;

            class  NovatelPsrdop2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelPsrdop2_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelPsrdop2_TypeSupportInterface_var _var_type;

                static NovatelPsrdop2_TypeSupportInterface_ptr _duplicate (NovatelPsrdop2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPsrdop2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPsrdop2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelPsrdop2_TypeSupportInterface () {};
                ~NovatelPsrdop2_TypeSupportInterface () {};
            private:
                NovatelPsrdop2_TypeSupportInterface (const NovatelPsrdop2_TypeSupportInterface &);
                NovatelPsrdop2_TypeSupportInterface & operator = (const NovatelPsrdop2_TypeSupportInterface &);
            };

            class  NovatelPsrdop2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelPsrdop2_DataWriter_ptr _ptr_type;
                typedef NovatelPsrdop2_DataWriter_var _var_type;

                static NovatelPsrdop2_DataWriter_ptr _duplicate (NovatelPsrdop2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPsrdop2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPsrdop2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelPsrdop2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelPsrdop2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelPsrdop2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelPsrdop2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelPsrdop2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelPsrdop2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelPsrdop2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelPsrdop2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelPsrdop2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelPsrdop2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelPsrdop2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPsrdop2_& instance_data) = 0;

            protected:
                NovatelPsrdop2_DataWriter () {};
                ~NovatelPsrdop2_DataWriter () {};
            private:
                NovatelPsrdop2_DataWriter (const NovatelPsrdop2_DataWriter &);
                NovatelPsrdop2_DataWriter & operator = (const NovatelPsrdop2_DataWriter &);
            };

            class  NovatelPsrdop2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelPsrdop2_DataReader_ptr _ptr_type;
                typedef NovatelPsrdop2_DataReader_var _var_type;

                static NovatelPsrdop2_DataReader_ptr _duplicate (NovatelPsrdop2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPsrdop2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPsrdop2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelPsrdop2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelPsrdop2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelPsrdop2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPsrdop2_& instance) = 0;

            protected:
                NovatelPsrdop2_DataReader () {};
                ~NovatelPsrdop2_DataReader () {};
            private:
                NovatelPsrdop2_DataReader (const NovatelPsrdop2_DataReader &);
                NovatelPsrdop2_DataReader & operator = (const NovatelPsrdop2_DataReader &);
            };

            class  NovatelPsrdop2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelPsrdop2_DataReaderView_ptr _ptr_type;
                typedef NovatelPsrdop2_DataReaderView_var _var_type;

                static NovatelPsrdop2_DataReaderView_ptr _duplicate (NovatelPsrdop2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelPsrdop2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelPsrdop2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelPsrdop2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelPsrdop2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelPsrdop2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelPsrdop2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelPsrdop2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelPsrdop2_& instance) = 0;

            protected:
                NovatelPsrdop2_DataReaderView () {};
                ~NovatelPsrdop2_DataReaderView () {};
            private:
                NovatelPsrdop2_DataReaderView (const NovatelPsrdop2_DataReaderView &);
                NovatelPsrdop2_DataReaderView & operator = (const NovatelPsrdop2_DataReaderView &);
            };
        }

    }

}

#endif
