#ifndef _H_054BAB7E56B335D814C1C62295F675AF_NovatelReceiverStatus__H_
#define _H_054BAB7E56B335D814C1C62295F675AF_NovatelReceiverStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  NovatelReceiverStatus_
            {
                ::DDS::ULong original_status_code_;
                ::DDS::Boolean error_flag_;
                ::DDS::Boolean temperature_flag_;
                ::DDS::Boolean voltage_supply_flag_;
                ::DDS::Boolean antenna_powered_;
                ::DDS::Boolean antenna_is_open_;
                ::DDS::Boolean antenna_is_shorted_;
                ::DDS::Boolean cpu_overload_flag_;
                ::DDS::Boolean com1_buffer_overrun_;
                ::DDS::Boolean com2_buffer_overrun_;
                ::DDS::Boolean com3_buffer_overrun_;
                ::DDS::Boolean usb_buffer_overrun_;
                ::DDS::Boolean rf1_agc_flag_;
                ::DDS::Boolean rf2_agc_flag_;
                ::DDS::Boolean almanac_flag_;
                ::DDS::Boolean position_solution_flag_;
                ::DDS::Boolean position_fixed_flag_;
                ::DDS::Boolean clock_steering_status_enabled_;
                ::DDS::Boolean clock_model_flag_;
                ::DDS::Boolean oemv_external_oscillator_flag_;
                ::DDS::Boolean software_resource_flag_;
                ::DDS::Boolean aux1_status_event_flag_;
                ::DDS::Boolean aux2_status_event_flag_;
                ::DDS::Boolean aux3_status_event_flag_;
            };

            typedef DDS_DCPSStruct_var<NovatelReceiverStatus_> NovatelReceiverStatus__var;
            typedef NovatelReceiverStatus_& NovatelReceiverStatus__out;

        }

    }

}

#endif /* _H_054BAB7E56B335D814C1C62295F675AF_NovatelReceiverStatus__H_ */
