#ifndef H_78152C732B6AD8D0C282862CFD285278_NovatelUtmPosition_SPLTYPES_H
#define H_78152C732B6AD8D0C282862CFD285278_NovatelUtmPosition_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_NovatelUtmPosition_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelExtendedSolutionStatus_SplDcps.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelSignalMask_SplDcps.h"



extern c_metaObject __NovatelUtmPosition__novatel_gps_msgs__load (c_base base);

extern c_metaObject __NovatelUtmPosition__novatel_gps_msgs_msg__load (c_base base);

extern c_metaObject __NovatelUtmPosition__novatel_gps_msgs_msg_dds___load (c_base base);

extern const char *novatel_gps_msgs_msg_dds__NovatelUtmPosition__metaDescriptor[];
extern const int novatel_gps_msgs_msg_dds__NovatelUtmPosition__metaDescriptorArrLength;
extern const int novatel_gps_msgs_msg_dds__NovatelUtmPosition__metaDescriptorLength;
extern c_metaObject __novatel_gps_msgs_msg_dds__NovatelUtmPosition___load (c_base base);
struct _novatel_gps_msgs_msg_dds__NovatelUtmPosition_ ;
extern  v_copyin_result __novatel_gps_msgs_msg_dds__NovatelUtmPosition___copyIn(c_base base, const struct novatel_gps_msgs::msg::dds_::NovatelUtmPosition_ *from, struct _novatel_gps_msgs_msg_dds__NovatelUtmPosition_ *to);
extern  void __novatel_gps_msgs_msg_dds__NovatelUtmPosition___copyOut(const void *_from, void *_to);
struct _novatel_gps_msgs_msg_dds__NovatelUtmPosition_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _novatel_gps_msgs_msg_dds__NovatelMessageHeader_ novatel_msg_header_;
    c_string solution_status_;
    c_string position_type_;
    c_ulong lon_zone_number_;
    c_string lat_zone_letter_;
    c_double northing_;
    c_double easting_;
    c_double height_;
    c_float undulation_;
    c_string datum_id_;
    c_float northing_sigma_;
    c_float easting_sigma_;
    c_float height_sigma_;
    c_string base_station_id_;
    c_float diff_age_;
    c_float solution_age_;
    c_octet num_satellites_tracked_;
    c_octet num_satellites_used_in_solution_;
    c_octet num_gps_and_glonass_l1_used_in_solution_;
    c_octet num_gps_and_glonass_l1_and_l2_used_in_solution_;
    struct _novatel_gps_msgs_msg_dds__NovatelExtendedSolutionStatus_ extended_solution_status_;
    struct _novatel_gps_msgs_msg_dds__NovatelSignalMask_ signal_mask_;
};

#undef OS_API
#endif
