#ifndef _H_A7C4BC32ABBDEBE66C0E2ABD4D4F4A3E_NovatelVelocity__H_
#define _H_A7C4BC32ABBDEBE66C0E2ABD4D4F4A3E_NovatelVelocity__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  NovatelVelocity_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::String_mgr solution_status_;
                ::DDS::String_mgr velocity_type_;
                ::DDS::Float latency_;
                ::DDS::Float age_;
                ::DDS::Double horizontal_speed_;
                ::DDS::Double track_ground_;
                ::DDS::Double vertical_speed_;
            };

            typedef DDS_DCPSStruct_var<NovatelVelocity_> NovatelVelocity__var;
            typedef DDS_DCPSStruct_out < NovatelVelocity_> NovatelVelocity__out;

        }

    }

}

#endif /* _H_A7C4BC32ABBDEBE66C0E2ABD4D4F4A3E_NovatelVelocity__H_ */
