#ifndef _H_A7C4BC32ABBDEBE66C0E2ABD4D4F4A3E_NovatelVelocity_DCPS_H_
#define _H_A7C4BC32ABBDEBE66C0E2ABD4D4F4A3E_NovatelVelocity_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelVelocity_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelVelocity_TypeSupportInterface;

            typedef NovatelVelocity_TypeSupportInterface * NovatelVelocity_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelVelocity_TypeSupportInterface> NovatelVelocity_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelVelocity_TypeSupportInterface> NovatelVelocity_TypeSupportInterface_out;


            class NovatelVelocity_DataWriter;

            typedef NovatelVelocity_DataWriter * NovatelVelocity_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelVelocity_DataWriter> NovatelVelocity_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelVelocity_DataWriter> NovatelVelocity_DataWriter_out;


            class NovatelVelocity_DataReader;

            typedef NovatelVelocity_DataReader * NovatelVelocity_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelVelocity_DataReader> NovatelVelocity_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelVelocity_DataReader> NovatelVelocity_DataReader_out;


            class NovatelVelocity_DataReaderView;

            typedef NovatelVelocity_DataReaderView * NovatelVelocity_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelVelocity_DataReaderView> NovatelVelocity_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelVelocity_DataReaderView> NovatelVelocity_DataReaderView_out;

            struct NovatelVelocity_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelVelocity_, struct NovatelVelocity_Seq_uniq_> NovatelVelocity_Seq;
            typedef DDS_DCPSSequence_var < NovatelVelocity_Seq> NovatelVelocity_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelVelocity_Seq> NovatelVelocity_Seq_out;

            class  NovatelVelocity_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelVelocity_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelVelocity_TypeSupportInterface_var _var_type;

                static NovatelVelocity_TypeSupportInterface_ptr _duplicate (NovatelVelocity_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelVelocity_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelVelocity_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelVelocity_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelVelocity_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelVelocity_TypeSupportInterface () {};
                ~NovatelVelocity_TypeSupportInterface () {};
            private:
                NovatelVelocity_TypeSupportInterface (const NovatelVelocity_TypeSupportInterface &);
                NovatelVelocity_TypeSupportInterface & operator = (const NovatelVelocity_TypeSupportInterface &);
            };

            class  NovatelVelocity_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelVelocity_DataWriter_ptr _ptr_type;
                typedef NovatelVelocity_DataWriter_var _var_type;

                static NovatelVelocity_DataWriter_ptr _duplicate (NovatelVelocity_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelVelocity_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelVelocity_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelVelocity_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelVelocity_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelVelocity_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelVelocity_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelVelocity_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelVelocity_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelVelocity_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelVelocity_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelVelocity_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelVelocity_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelVelocity_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelVelocity_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelVelocity_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelVelocity_& instance_data) = 0;

            protected:
                NovatelVelocity_DataWriter () {};
                ~NovatelVelocity_DataWriter () {};
            private:
                NovatelVelocity_DataWriter (const NovatelVelocity_DataWriter &);
                NovatelVelocity_DataWriter & operator = (const NovatelVelocity_DataWriter &);
            };

            class  NovatelVelocity_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelVelocity_DataReader_ptr _ptr_type;
                typedef NovatelVelocity_DataReader_var _var_type;

                static NovatelVelocity_DataReader_ptr _duplicate (NovatelVelocity_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelVelocity_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelVelocity_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelVelocity_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelVelocity_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelVelocity_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelVelocity_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelVelocity_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelVelocity_& instance) = 0;

            protected:
                NovatelVelocity_DataReader () {};
                ~NovatelVelocity_DataReader () {};
            private:
                NovatelVelocity_DataReader (const NovatelVelocity_DataReader &);
                NovatelVelocity_DataReader & operator = (const NovatelVelocity_DataReader &);
            };

            class  NovatelVelocity_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelVelocity_DataReaderView_ptr _ptr_type;
                typedef NovatelVelocity_DataReaderView_var _var_type;

                static NovatelVelocity_DataReaderView_ptr _duplicate (NovatelVelocity_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelVelocity_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelVelocity_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelVelocity_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelVelocity_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelVelocity_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelVelocity_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelVelocity_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelVelocity_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelVelocity_& instance) = 0;

            protected:
                NovatelVelocity_DataReaderView () {};
                ~NovatelVelocity_DataReaderView () {};
            private:
                NovatelVelocity_DataReaderView (const NovatelVelocity_DataReaderView &);
                NovatelVelocity_DataReaderView & operator = (const NovatelVelocity_DataReaderView &);
            };
        }

    }

}

#endif
