#ifndef _H_3F289B1AEF95D61D971F07708BF13E97_NovatelXYZ__H_
#define _H_3F289B1AEF95D61D971F07708BF13E97_NovatelXYZ__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelExtendedSolutionStatus_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelSignalMask_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  NovatelXYZ_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::String_mgr solution_status_;
                ::DDS::String_mgr position_type_;
                ::DDS::Double x_;
                ::DDS::Double y_;
                ::DDS::Double z_;
                ::DDS::Float x_sigma_;
                ::DDS::Float y_sigma_;
                ::DDS::Float z_sigma_;
                ::DDS::String_mgr velocity_solution_status_;
                ::DDS::String_mgr velocity_type_;
                ::DDS::Double x_vel_;
                ::DDS::Double y_vel_;
                ::DDS::Double z_vel_;
                ::DDS::Float x_vel_sigma_;
                ::DDS::Float y_vel_sigma_;
                ::DDS::Float z_vel_sigma_;
                ::DDS::String_mgr base_station_id_;
                ::DDS::Float velocity_latency_;
                ::DDS::Float diff_age_;
                ::DDS::Float solution_age_;
                ::DDS::Octet num_satellites_tracked_;
                ::DDS::Octet num_satellites_used_in_solution_;
                ::DDS::Octet num_gps_and_glonass_l1_used_in_solution_;
                ::DDS::Octet num_gps_and_glonass_l1_and_l2_used_in_solution_;
                ::novatel_gps_msgs::msg::dds_::NovatelExtendedSolutionStatus_ extended_solution_status_;
                ::novatel_gps_msgs::msg::dds_::NovatelSignalMask_ signal_mask_;
            };

            typedef DDS_DCPSStruct_var<NovatelXYZ_> NovatelXYZ__var;
            typedef DDS_DCPSStruct_out < NovatelXYZ_> NovatelXYZ__out;

        }

    }

}

#endif /* _H_3F289B1AEF95D61D971F07708BF13E97_NovatelXYZ__H_ */
