#ifndef _H_3F289B1AEF95D61D971F07708BF13E97_NovatelXYZ_DCPS_H_
#define _H_3F289B1AEF95D61D971F07708BF13E97_NovatelXYZ_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelXYZ_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelXYZ_TypeSupportInterface;

            typedef NovatelXYZ_TypeSupportInterface * NovatelXYZ_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelXYZ_TypeSupportInterface> NovatelXYZ_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelXYZ_TypeSupportInterface> NovatelXYZ_TypeSupportInterface_out;


            class NovatelXYZ_DataWriter;

            typedef NovatelXYZ_DataWriter * NovatelXYZ_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelXYZ_DataWriter> NovatelXYZ_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelXYZ_DataWriter> NovatelXYZ_DataWriter_out;


            class NovatelXYZ_DataReader;

            typedef NovatelXYZ_DataReader * NovatelXYZ_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelXYZ_DataReader> NovatelXYZ_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelXYZ_DataReader> NovatelXYZ_DataReader_out;


            class NovatelXYZ_DataReaderView;

            typedef NovatelXYZ_DataReaderView * NovatelXYZ_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelXYZ_DataReaderView> NovatelXYZ_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelXYZ_DataReaderView> NovatelXYZ_DataReaderView_out;

            struct NovatelXYZ_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelXYZ_, struct NovatelXYZ_Seq_uniq_> NovatelXYZ_Seq;
            typedef DDS_DCPSSequence_var < NovatelXYZ_Seq> NovatelXYZ_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelXYZ_Seq> NovatelXYZ_Seq_out;

            class  NovatelXYZ_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelXYZ_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelXYZ_TypeSupportInterface_var _var_type;

                static NovatelXYZ_TypeSupportInterface_ptr _duplicate (NovatelXYZ_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelXYZ_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelXYZ_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelXYZ_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelXYZ_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelXYZ_TypeSupportInterface () {};
                ~NovatelXYZ_TypeSupportInterface () {};
            private:
                NovatelXYZ_TypeSupportInterface (const NovatelXYZ_TypeSupportInterface &);
                NovatelXYZ_TypeSupportInterface & operator = (const NovatelXYZ_TypeSupportInterface &);
            };

            class  NovatelXYZ_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelXYZ_DataWriter_ptr _ptr_type;
                typedef NovatelXYZ_DataWriter_var _var_type;

                static NovatelXYZ_DataWriter_ptr _duplicate (NovatelXYZ_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelXYZ_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelXYZ_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelXYZ_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelXYZ_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelXYZ_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelXYZ_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelXYZ_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelXYZ_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelXYZ_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelXYZ_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelXYZ_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelXYZ_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelXYZ_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelXYZ_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelXYZ_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelXYZ_& instance_data) = 0;

            protected:
                NovatelXYZ_DataWriter () {};
                ~NovatelXYZ_DataWriter () {};
            private:
                NovatelXYZ_DataWriter (const NovatelXYZ_DataWriter &);
                NovatelXYZ_DataWriter & operator = (const NovatelXYZ_DataWriter &);
            };

            class  NovatelXYZ_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelXYZ_DataReader_ptr _ptr_type;
                typedef NovatelXYZ_DataReader_var _var_type;

                static NovatelXYZ_DataReader_ptr _duplicate (NovatelXYZ_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelXYZ_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelXYZ_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelXYZ_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelXYZ_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelXYZ_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelXYZ_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelXYZ_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelXYZ_& instance) = 0;

            protected:
                NovatelXYZ_DataReader () {};
                ~NovatelXYZ_DataReader () {};
            private:
                NovatelXYZ_DataReader (const NovatelXYZ_DataReader &);
                NovatelXYZ_DataReader & operator = (const NovatelXYZ_DataReader &);
            };

            class  NovatelXYZ_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelXYZ_DataReaderView_ptr _ptr_type;
                typedef NovatelXYZ_DataReaderView_var _var_type;

                static NovatelXYZ_DataReaderView_ptr _duplicate (NovatelXYZ_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelXYZ_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelXYZ_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelXYZ_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelXYZ_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelXYZ_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelXYZ_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelXYZ_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelXYZ_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelXYZ_& instance) = 0;

            protected:
                NovatelXYZ_DataReaderView () {};
                ~NovatelXYZ_DataReaderView () {};
            private:
                NovatelXYZ_DataReaderView (const NovatelXYZ_DataReaderView &);
                NovatelXYZ_DataReaderView & operator = (const NovatelXYZ_DataReaderView &);
            };
        }

    }

}

#endif
