#ifndef _H_D286302B580718E138437D3F2F906AB6_RangeInformation_DCPS_H_
#define _H_D286302B580718E138437D3F2F906AB6_RangeInformation_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RangeInformation_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RangeInformation_TypeSupportInterface;

            typedef RangeInformation_TypeSupportInterface * RangeInformation_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RangeInformation_TypeSupportInterface> RangeInformation_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RangeInformation_TypeSupportInterface> RangeInformation_TypeSupportInterface_out;


            class RangeInformation_DataWriter;

            typedef RangeInformation_DataWriter * RangeInformation_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RangeInformation_DataWriter> RangeInformation_DataWriter_var;
            typedef DDS_DCPSInterface_out < RangeInformation_DataWriter> RangeInformation_DataWriter_out;


            class RangeInformation_DataReader;

            typedef RangeInformation_DataReader * RangeInformation_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RangeInformation_DataReader> RangeInformation_DataReader_var;
            typedef DDS_DCPSInterface_out < RangeInformation_DataReader> RangeInformation_DataReader_out;


            class RangeInformation_DataReaderView;

            typedef RangeInformation_DataReaderView * RangeInformation_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RangeInformation_DataReaderView> RangeInformation_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RangeInformation_DataReaderView> RangeInformation_DataReaderView_out;

            struct RangeInformation_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RangeInformation_, struct RangeInformation_Seq_uniq_> RangeInformation_Seq;
            typedef DDS_DCPSSequence_var < RangeInformation_Seq> RangeInformation_Seq_var;
            typedef DDS_DCPSSequence_out < RangeInformation_Seq> RangeInformation_Seq_out;

            class  RangeInformation_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RangeInformation_TypeSupportInterface_ptr _ptr_type;
                typedef RangeInformation_TypeSupportInterface_var _var_type;

                static RangeInformation_TypeSupportInterface_ptr _duplicate (RangeInformation_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeInformation_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RangeInformation_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeInformation_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeInformation_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RangeInformation_TypeSupportInterface () {};
                ~RangeInformation_TypeSupportInterface () {};
            private:
                RangeInformation_TypeSupportInterface (const RangeInformation_TypeSupportInterface &);
                RangeInformation_TypeSupportInterface & operator = (const RangeInformation_TypeSupportInterface &);
            };

            class  RangeInformation_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RangeInformation_DataWriter_ptr _ptr_type;
                typedef RangeInformation_DataWriter_var _var_type;

                static RangeInformation_DataWriter_ptr _duplicate (RangeInformation_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeInformation_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RangeInformation_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeInformation_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeInformation_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RangeInformation_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RangeInformation_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RangeInformation_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RangeInformation_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RangeInformation_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RangeInformation_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RangeInformation_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RangeInformation_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RangeInformation_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RangeInformation_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RangeInformation_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeInformation_& instance_data) = 0;

            protected:
                RangeInformation_DataWriter () {};
                ~RangeInformation_DataWriter () {};
            private:
                RangeInformation_DataWriter (const RangeInformation_DataWriter &);
                RangeInformation_DataWriter & operator = (const RangeInformation_DataWriter &);
            };

            class  RangeInformation_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RangeInformation_DataReader_ptr _ptr_type;
                typedef RangeInformation_DataReader_var _var_type;

                static RangeInformation_DataReader_ptr _duplicate (RangeInformation_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeInformation_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RangeInformation_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeInformation_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeInformation_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RangeInformation_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RangeInformation_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RangeInformation_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeInformation_& instance) = 0;

            protected:
                RangeInformation_DataReader () {};
                ~RangeInformation_DataReader () {};
            private:
                RangeInformation_DataReader (const RangeInformation_DataReader &);
                RangeInformation_DataReader & operator = (const RangeInformation_DataReader &);
            };

            class  RangeInformation_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RangeInformation_DataReaderView_ptr _ptr_type;
                typedef RangeInformation_DataReaderView_var _var_type;

                static RangeInformation_DataReaderView_ptr _duplicate (RangeInformation_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeInformation_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RangeInformation_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeInformation_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeInformation_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RangeInformation_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RangeInformation_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RangeInformation_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RangeInformation_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeInformation_& instance) = 0;

            protected:
                RangeInformation_DataReaderView () {};
                ~RangeInformation_DataReaderView () {};
            private:
                RangeInformation_DataReaderView (const RangeInformation_DataReaderView &);
                RangeInformation_DataReaderView & operator = (const RangeInformation_DataReaderView &);
            };
        }

    }

}

#endif
