#ifndef _H_C5823F1F57A1809E7F6B79116BB49DDD_TrackstatChannel_DCPS_H_
#define _H_C5823F1F57A1809E7F6B79116BB49DDD_TrackstatChannel_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TrackstatChannel_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TrackstatChannel_TypeSupportInterface;

            typedef TrackstatChannel_TypeSupportInterface * TrackstatChannel_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TrackstatChannel_TypeSupportInterface> TrackstatChannel_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TrackstatChannel_TypeSupportInterface> TrackstatChannel_TypeSupportInterface_out;


            class TrackstatChannel_DataWriter;

            typedef TrackstatChannel_DataWriter * TrackstatChannel_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TrackstatChannel_DataWriter> TrackstatChannel_DataWriter_var;
            typedef DDS_DCPSInterface_out < TrackstatChannel_DataWriter> TrackstatChannel_DataWriter_out;


            class TrackstatChannel_DataReader;

            typedef TrackstatChannel_DataReader * TrackstatChannel_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TrackstatChannel_DataReader> TrackstatChannel_DataReader_var;
            typedef DDS_DCPSInterface_out < TrackstatChannel_DataReader> TrackstatChannel_DataReader_out;


            class TrackstatChannel_DataReaderView;

            typedef TrackstatChannel_DataReaderView * TrackstatChannel_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TrackstatChannel_DataReaderView> TrackstatChannel_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TrackstatChannel_DataReaderView> TrackstatChannel_DataReaderView_out;

            struct TrackstatChannel_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TrackstatChannel_, struct TrackstatChannel_Seq_uniq_> TrackstatChannel_Seq;
            typedef DDS_DCPSSequence_var < TrackstatChannel_Seq> TrackstatChannel_Seq_var;
            typedef DDS_DCPSSequence_out < TrackstatChannel_Seq> TrackstatChannel_Seq_out;

            class  TrackstatChannel_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TrackstatChannel_TypeSupportInterface_ptr _ptr_type;
                typedef TrackstatChannel_TypeSupportInterface_var _var_type;

                static TrackstatChannel_TypeSupportInterface_ptr _duplicate (TrackstatChannel_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackstatChannel_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TrackstatChannel_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackstatChannel_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackstatChannel_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TrackstatChannel_TypeSupportInterface () {};
                ~TrackstatChannel_TypeSupportInterface () {};
            private:
                TrackstatChannel_TypeSupportInterface (const TrackstatChannel_TypeSupportInterface &);
                TrackstatChannel_TypeSupportInterface & operator = (const TrackstatChannel_TypeSupportInterface &);
            };

            class  TrackstatChannel_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TrackstatChannel_DataWriter_ptr _ptr_type;
                typedef TrackstatChannel_DataWriter_var _var_type;

                static TrackstatChannel_DataWriter_ptr _duplicate (TrackstatChannel_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackstatChannel_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TrackstatChannel_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackstatChannel_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackstatChannel_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TrackstatChannel_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TrackstatChannel_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TrackstatChannel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TrackstatChannel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TrackstatChannel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TrackstatChannel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TrackstatChannel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TrackstatChannel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TrackstatChannel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TrackstatChannel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TrackstatChannel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackstatChannel_& instance_data) = 0;

            protected:
                TrackstatChannel_DataWriter () {};
                ~TrackstatChannel_DataWriter () {};
            private:
                TrackstatChannel_DataWriter (const TrackstatChannel_DataWriter &);
                TrackstatChannel_DataWriter & operator = (const TrackstatChannel_DataWriter &);
            };

            class  TrackstatChannel_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TrackstatChannel_DataReader_ptr _ptr_type;
                typedef TrackstatChannel_DataReader_var _var_type;

                static TrackstatChannel_DataReader_ptr _duplicate (TrackstatChannel_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackstatChannel_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TrackstatChannel_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackstatChannel_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackstatChannel_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrackstatChannel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrackstatChannel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrackstatChannel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackstatChannel_& instance) = 0;

            protected:
                TrackstatChannel_DataReader () {};
                ~TrackstatChannel_DataReader () {};
            private:
                TrackstatChannel_DataReader (const TrackstatChannel_DataReader &);
                TrackstatChannel_DataReader & operator = (const TrackstatChannel_DataReader &);
            };

            class  TrackstatChannel_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TrackstatChannel_DataReaderView_ptr _ptr_type;
                typedef TrackstatChannel_DataReaderView_var _var_type;

                static TrackstatChannel_DataReaderView_ptr _duplicate (TrackstatChannel_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackstatChannel_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TrackstatChannel_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackstatChannel_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackstatChannel_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrackstatChannel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrackstatChannel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrackstatChannel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrackstatChannel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackstatChannel_& instance) = 0;

            protected:
                TrackstatChannel_DataReaderView () {};
                ~TrackstatChannel_DataReaderView () {};
            private:
                TrackstatChannel_DataReaderView (const TrackstatChannel_DataReaderView &);
                TrackstatChannel_DataReaderView & operator = (const TrackstatChannel_DataReaderView &);
            };
        }

    }

}

#endif
