#ifndef _H_B819F28835F5ADB9368DD9FBE8F980FB_Trackstat_DCPS_H_
#define _H_B819F28835F5ADB9368DD9FBE8F980FB_Trackstat_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Trackstat_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Trackstat_TypeSupportInterface;

            typedef Trackstat_TypeSupportInterface * Trackstat_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Trackstat_TypeSupportInterface> Trackstat_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Trackstat_TypeSupportInterface> Trackstat_TypeSupportInterface_out;


            class Trackstat_DataWriter;

            typedef Trackstat_DataWriter * Trackstat_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Trackstat_DataWriter> Trackstat_DataWriter_var;
            typedef DDS_DCPSInterface_out < Trackstat_DataWriter> Trackstat_DataWriter_out;


            class Trackstat_DataReader;

            typedef Trackstat_DataReader * Trackstat_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Trackstat_DataReader> Trackstat_DataReader_var;
            typedef DDS_DCPSInterface_out < Trackstat_DataReader> Trackstat_DataReader_out;


            class Trackstat_DataReaderView;

            typedef Trackstat_DataReaderView * Trackstat_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Trackstat_DataReaderView> Trackstat_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Trackstat_DataReaderView> Trackstat_DataReaderView_out;

            struct Trackstat_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Trackstat_, struct Trackstat_Seq_uniq_> Trackstat_Seq;
            typedef DDS_DCPSSequence_var < Trackstat_Seq> Trackstat_Seq_var;
            typedef DDS_DCPSSequence_out < Trackstat_Seq> Trackstat_Seq_out;

            class  Trackstat_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Trackstat_TypeSupportInterface_ptr _ptr_type;
                typedef Trackstat_TypeSupportInterface_var _var_type;

                static Trackstat_TypeSupportInterface_ptr _duplicate (Trackstat_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Trackstat_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Trackstat_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Trackstat_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Trackstat_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Trackstat_TypeSupportInterface () {};
                ~Trackstat_TypeSupportInterface () {};
            private:
                Trackstat_TypeSupportInterface (const Trackstat_TypeSupportInterface &);
                Trackstat_TypeSupportInterface & operator = (const Trackstat_TypeSupportInterface &);
            };

            class  Trackstat_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Trackstat_DataWriter_ptr _ptr_type;
                typedef Trackstat_DataWriter_var _var_type;

                static Trackstat_DataWriter_ptr _duplicate (Trackstat_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Trackstat_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Trackstat_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Trackstat_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Trackstat_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Trackstat_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Trackstat_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Trackstat_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Trackstat_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Trackstat_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Trackstat_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Trackstat_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Trackstat_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Trackstat_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Trackstat_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Trackstat_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Trackstat_& instance_data) = 0;

            protected:
                Trackstat_DataWriter () {};
                ~Trackstat_DataWriter () {};
            private:
                Trackstat_DataWriter (const Trackstat_DataWriter &);
                Trackstat_DataWriter & operator = (const Trackstat_DataWriter &);
            };

            class  Trackstat_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Trackstat_DataReader_ptr _ptr_type;
                typedef Trackstat_DataReader_var _var_type;

                static Trackstat_DataReader_ptr _duplicate (Trackstat_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Trackstat_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Trackstat_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Trackstat_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Trackstat_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Trackstat_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Trackstat_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Trackstat_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Trackstat_& instance) = 0;

            protected:
                Trackstat_DataReader () {};
                ~Trackstat_DataReader () {};
            private:
                Trackstat_DataReader (const Trackstat_DataReader &);
                Trackstat_DataReader & operator = (const Trackstat_DataReader &);
            };

            class  Trackstat_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Trackstat_DataReaderView_ptr _ptr_type;
                typedef Trackstat_DataReaderView_var _var_type;

                static Trackstat_DataReaderView_ptr _duplicate (Trackstat_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Trackstat_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Trackstat_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Trackstat_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Trackstat_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Trackstat_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Trackstat_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Trackstat_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Trackstat_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Trackstat_& instance) = 0;

            protected:
                Trackstat_DataReaderView () {};
                ~Trackstat_DataReaderView () {};
            private:
                Trackstat_DataReaderView (const Trackstat_DataReaderView &);
                Trackstat_DataReaderView & operator = (const Trackstat_DataReaderView &);
            };
        }

    }

}

#endif
