// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/NovatelHeading2.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/novatel_heading2__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `novatel_msg_header`
#include "novatel_gps_msgs/msg/novatel_message_header__functions.h"
// Member `solution_status`
// Member `position_type`
// Member `rover_station_id`
// Member `master_station_id`
#include "rosidl_generator_c/string_functions.h"
// Member `extended_solution_status`
#include "novatel_gps_msgs/msg/novatel_extended_solution_status__functions.h"
// Member `signal_mask`
#include "novatel_gps_msgs/msg/novatel_signal_mask__functions.h"

bool
novatel_gps_msgs__msg__NovatelHeading2__init(novatel_gps_msgs__msg__NovatelHeading2 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
    return false;
  }
  // novatel_msg_header
  if (!novatel_gps_msgs__msg__NovatelMessageHeader__init(&msg->novatel_msg_header)) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
    return false;
  }
  // solution_status
  if (!rosidl_generator_c__String__init(&msg->solution_status)) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
    return false;
  }
  // position_type
  if (!rosidl_generator_c__String__init(&msg->position_type)) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
    return false;
  }
  // baseline_length
  // heading
  // pitch
  // heading_sigma
  // pitch_sigma
  // rover_station_id
  if (!rosidl_generator_c__String__init(&msg->rover_station_id)) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
    return false;
  }
  // master_station_id
  if (!rosidl_generator_c__String__init(&msg->master_station_id)) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
    return false;
  }
  // num_satellites_tracked
  // num_satellites_used_in_solution
  // num_satellites_above_elevation_mask_angle
  // num_satellites_above_elevation_mask_angle_l2
  // solution_source
  // extended_solution_status
  if (!novatel_gps_msgs__msg__NovatelExtendedSolutionStatus__init(&msg->extended_solution_status)) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
    return false;
  }
  // signal_mask
  if (!novatel_gps_msgs__msg__NovatelSignalMask__init(&msg->signal_mask)) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
    return false;
  }
  return true;
}

void
novatel_gps_msgs__msg__NovatelHeading2__fini(novatel_gps_msgs__msg__NovatelHeading2 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // novatel_msg_header
  novatel_gps_msgs__msg__NovatelMessageHeader__fini(&msg->novatel_msg_header);
  // solution_status
  rosidl_generator_c__String__fini(&msg->solution_status);
  // position_type
  rosidl_generator_c__String__fini(&msg->position_type);
  // baseline_length
  // heading
  // pitch
  // heading_sigma
  // pitch_sigma
  // rover_station_id
  rosidl_generator_c__String__fini(&msg->rover_station_id);
  // master_station_id
  rosidl_generator_c__String__fini(&msg->master_station_id);
  // num_satellites_tracked
  // num_satellites_used_in_solution
  // num_satellites_above_elevation_mask_angle
  // num_satellites_above_elevation_mask_angle_l2
  // solution_source
  // extended_solution_status
  novatel_gps_msgs__msg__NovatelExtendedSolutionStatus__fini(&msg->extended_solution_status);
  // signal_mask
  novatel_gps_msgs__msg__NovatelSignalMask__fini(&msg->signal_mask);
}

novatel_gps_msgs__msg__NovatelHeading2 *
novatel_gps_msgs__msg__NovatelHeading2__create()
{
  novatel_gps_msgs__msg__NovatelHeading2 * msg = (novatel_gps_msgs__msg__NovatelHeading2 *)malloc(sizeof(novatel_gps_msgs__msg__NovatelHeading2));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__NovatelHeading2));
  bool success = novatel_gps_msgs__msg__NovatelHeading2__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__NovatelHeading2__destroy(novatel_gps_msgs__msg__NovatelHeading2 * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__NovatelHeading2__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__NovatelHeading2__Sequence__init(novatel_gps_msgs__msg__NovatelHeading2__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__NovatelHeading2 * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__NovatelHeading2 *)calloc(size, sizeof(novatel_gps_msgs__msg__NovatelHeading2));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__NovatelHeading2__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__NovatelHeading2__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__NovatelHeading2__Sequence__fini(novatel_gps_msgs__msg__NovatelHeading2__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__NovatelHeading2__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__NovatelHeading2__Sequence *
novatel_gps_msgs__msg__NovatelHeading2__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__NovatelHeading2__Sequence * array = (novatel_gps_msgs__msg__NovatelHeading2__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__NovatelHeading2__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__NovatelHeading2__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__NovatelHeading2__Sequence__destroy(novatel_gps_msgs__msg__NovatelHeading2__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__NovatelHeading2__Sequence__fini(array);
  }
  free(array);
}
