// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/NovatelVelocity.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/novatel_velocity__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `novatel_msg_header`
#include "novatel_gps_msgs/msg/novatel_message_header__functions.h"
// Member `solution_status`
// Member `velocity_type`
#include "rosidl_generator_c/string_functions.h"

bool
novatel_gps_msgs__msg__NovatelVelocity__init(novatel_gps_msgs__msg__NovatelVelocity * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__NovatelVelocity__fini(msg);
    return false;
  }
  // novatel_msg_header
  if (!novatel_gps_msgs__msg__NovatelMessageHeader__init(&msg->novatel_msg_header)) {
    novatel_gps_msgs__msg__NovatelVelocity__fini(msg);
    return false;
  }
  // solution_status
  if (!rosidl_generator_c__String__init(&msg->solution_status)) {
    novatel_gps_msgs__msg__NovatelVelocity__fini(msg);
    return false;
  }
  // velocity_type
  if (!rosidl_generator_c__String__init(&msg->velocity_type)) {
    novatel_gps_msgs__msg__NovatelVelocity__fini(msg);
    return false;
  }
  // latency
  // age
  // horizontal_speed
  // track_ground
  // vertical_speed
  return true;
}

void
novatel_gps_msgs__msg__NovatelVelocity__fini(novatel_gps_msgs__msg__NovatelVelocity * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // novatel_msg_header
  novatel_gps_msgs__msg__NovatelMessageHeader__fini(&msg->novatel_msg_header);
  // solution_status
  rosidl_generator_c__String__fini(&msg->solution_status);
  // velocity_type
  rosidl_generator_c__String__fini(&msg->velocity_type);
  // latency
  // age
  // horizontal_speed
  // track_ground
  // vertical_speed
}

novatel_gps_msgs__msg__NovatelVelocity *
novatel_gps_msgs__msg__NovatelVelocity__create()
{
  novatel_gps_msgs__msg__NovatelVelocity * msg = (novatel_gps_msgs__msg__NovatelVelocity *)malloc(sizeof(novatel_gps_msgs__msg__NovatelVelocity));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__NovatelVelocity));
  bool success = novatel_gps_msgs__msg__NovatelVelocity__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__NovatelVelocity__destroy(novatel_gps_msgs__msg__NovatelVelocity * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__NovatelVelocity__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__NovatelVelocity__Sequence__init(novatel_gps_msgs__msg__NovatelVelocity__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__NovatelVelocity * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__NovatelVelocity *)calloc(size, sizeof(novatel_gps_msgs__msg__NovatelVelocity));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__NovatelVelocity__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__NovatelVelocity__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__NovatelVelocity__Sequence__fini(novatel_gps_msgs__msg__NovatelVelocity__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__NovatelVelocity__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__NovatelVelocity__Sequence *
novatel_gps_msgs__msg__NovatelVelocity__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__NovatelVelocity__Sequence * array = (novatel_gps_msgs__msg__NovatelVelocity__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__NovatelVelocity__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__NovatelVelocity__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__NovatelVelocity__Sequence__destroy(novatel_gps_msgs__msg__NovatelVelocity__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__NovatelVelocity__Sequence__fini(array);
  }
  free(array);
}
