#ifndef _H_B23E4BAEA991AD8CAD8799B58CB95304_NovatelFRESET_DCPS_H_
#define _H_B23E4BAEA991AD8CAD8799B58CB95304_NovatelFRESET_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelFRESET_.h"


namespace novatel_gps_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class NovatelFRESET_Request_TypeSupportInterface;

            typedef NovatelFRESET_Request_TypeSupportInterface * NovatelFRESET_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelFRESET_Request_TypeSupportInterface> NovatelFRESET_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelFRESET_Request_TypeSupportInterface> NovatelFRESET_Request_TypeSupportInterface_out;


            class NovatelFRESET_Request_DataWriter;

            typedef NovatelFRESET_Request_DataWriter * NovatelFRESET_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelFRESET_Request_DataWriter> NovatelFRESET_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelFRESET_Request_DataWriter> NovatelFRESET_Request_DataWriter_out;


            class NovatelFRESET_Request_DataReader;

            typedef NovatelFRESET_Request_DataReader * NovatelFRESET_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelFRESET_Request_DataReader> NovatelFRESET_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelFRESET_Request_DataReader> NovatelFRESET_Request_DataReader_out;


            class NovatelFRESET_Request_DataReaderView;

            typedef NovatelFRESET_Request_DataReaderView * NovatelFRESET_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelFRESET_Request_DataReaderView> NovatelFRESET_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelFRESET_Request_DataReaderView> NovatelFRESET_Request_DataReaderView_out;

            struct NovatelFRESET_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelFRESET_Request_, struct NovatelFRESET_Request_Seq_uniq_> NovatelFRESET_Request_Seq;
            typedef DDS_DCPSSequence_var < NovatelFRESET_Request_Seq> NovatelFRESET_Request_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelFRESET_Request_Seq> NovatelFRESET_Request_Seq_out;

            class  NovatelFRESET_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelFRESET_Request_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelFRESET_Request_TypeSupportInterface_var _var_type;

                static NovatelFRESET_Request_TypeSupportInterface_ptr _duplicate (NovatelFRESET_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelFRESET_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelFRESET_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelFRESET_Request_TypeSupportInterface () {};
                ~NovatelFRESET_Request_TypeSupportInterface () {};
            private:
                NovatelFRESET_Request_TypeSupportInterface (const NovatelFRESET_Request_TypeSupportInterface &);
                NovatelFRESET_Request_TypeSupportInterface & operator = (const NovatelFRESET_Request_TypeSupportInterface &);
            };

            class  NovatelFRESET_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelFRESET_Request_DataWriter_ptr _ptr_type;
                typedef NovatelFRESET_Request_DataWriter_var _var_type;

                static NovatelFRESET_Request_DataWriter_ptr _duplicate (NovatelFRESET_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelFRESET_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelFRESET_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelFRESET_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelFRESET_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelFRESET_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelFRESET_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelFRESET_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelFRESET_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelFRESET_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelFRESET_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelFRESET_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelFRESET_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelFRESET_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelFRESET_Request_& instance_data) = 0;

            protected:
                NovatelFRESET_Request_DataWriter () {};
                ~NovatelFRESET_Request_DataWriter () {};
            private:
                NovatelFRESET_Request_DataWriter (const NovatelFRESET_Request_DataWriter &);
                NovatelFRESET_Request_DataWriter & operator = (const NovatelFRESET_Request_DataWriter &);
            };

            class  NovatelFRESET_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelFRESET_Request_DataReader_ptr _ptr_type;
                typedef NovatelFRESET_Request_DataReader_var _var_type;

                static NovatelFRESET_Request_DataReader_ptr _duplicate (NovatelFRESET_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelFRESET_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelFRESET_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelFRESET_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelFRESET_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelFRESET_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelFRESET_Request_& instance) = 0;

            protected:
                NovatelFRESET_Request_DataReader () {};
                ~NovatelFRESET_Request_DataReader () {};
            private:
                NovatelFRESET_Request_DataReader (const NovatelFRESET_Request_DataReader &);
                NovatelFRESET_Request_DataReader & operator = (const NovatelFRESET_Request_DataReader &);
            };

            class  NovatelFRESET_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelFRESET_Request_DataReaderView_ptr _ptr_type;
                typedef NovatelFRESET_Request_DataReaderView_var _var_type;

                static NovatelFRESET_Request_DataReaderView_ptr _duplicate (NovatelFRESET_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelFRESET_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelFRESET_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelFRESET_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelFRESET_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelFRESET_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelFRESET_Request_& instance) = 0;

            protected:
                NovatelFRESET_Request_DataReaderView () {};
                ~NovatelFRESET_Request_DataReaderView () {};
            private:
                NovatelFRESET_Request_DataReaderView (const NovatelFRESET_Request_DataReaderView &);
                NovatelFRESET_Request_DataReaderView & operator = (const NovatelFRESET_Request_DataReaderView &);
            };
            class NovatelFRESET_Response_TypeSupportInterface;

            typedef NovatelFRESET_Response_TypeSupportInterface * NovatelFRESET_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelFRESET_Response_TypeSupportInterface> NovatelFRESET_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelFRESET_Response_TypeSupportInterface> NovatelFRESET_Response_TypeSupportInterface_out;


            class NovatelFRESET_Response_DataWriter;

            typedef NovatelFRESET_Response_DataWriter * NovatelFRESET_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelFRESET_Response_DataWriter> NovatelFRESET_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelFRESET_Response_DataWriter> NovatelFRESET_Response_DataWriter_out;


            class NovatelFRESET_Response_DataReader;

            typedef NovatelFRESET_Response_DataReader * NovatelFRESET_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelFRESET_Response_DataReader> NovatelFRESET_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelFRESET_Response_DataReader> NovatelFRESET_Response_DataReader_out;


            class NovatelFRESET_Response_DataReaderView;

            typedef NovatelFRESET_Response_DataReaderView * NovatelFRESET_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelFRESET_Response_DataReaderView> NovatelFRESET_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelFRESET_Response_DataReaderView> NovatelFRESET_Response_DataReaderView_out;

            struct NovatelFRESET_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < NovatelFRESET_Response_, struct NovatelFRESET_Response_Seq_uniq_> NovatelFRESET_Response_Seq;
            typedef DDS_DCPSSequence_var < NovatelFRESET_Response_Seq> NovatelFRESET_Response_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelFRESET_Response_Seq> NovatelFRESET_Response_Seq_out;

            class  NovatelFRESET_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelFRESET_Response_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelFRESET_Response_TypeSupportInterface_var _var_type;

                static NovatelFRESET_Response_TypeSupportInterface_ptr _duplicate (NovatelFRESET_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelFRESET_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelFRESET_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelFRESET_Response_TypeSupportInterface () {};
                ~NovatelFRESET_Response_TypeSupportInterface () {};
            private:
                NovatelFRESET_Response_TypeSupportInterface (const NovatelFRESET_Response_TypeSupportInterface &);
                NovatelFRESET_Response_TypeSupportInterface & operator = (const NovatelFRESET_Response_TypeSupportInterface &);
            };

            class  NovatelFRESET_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelFRESET_Response_DataWriter_ptr _ptr_type;
                typedef NovatelFRESET_Response_DataWriter_var _var_type;

                static NovatelFRESET_Response_DataWriter_ptr _duplicate (NovatelFRESET_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelFRESET_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelFRESET_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelFRESET_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelFRESET_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelFRESET_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelFRESET_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelFRESET_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelFRESET_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelFRESET_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelFRESET_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelFRESET_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelFRESET_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelFRESET_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelFRESET_Response_& instance_data) = 0;

            protected:
                NovatelFRESET_Response_DataWriter () {};
                ~NovatelFRESET_Response_DataWriter () {};
            private:
                NovatelFRESET_Response_DataWriter (const NovatelFRESET_Response_DataWriter &);
                NovatelFRESET_Response_DataWriter & operator = (const NovatelFRESET_Response_DataWriter &);
            };

            class  NovatelFRESET_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelFRESET_Response_DataReader_ptr _ptr_type;
                typedef NovatelFRESET_Response_DataReader_var _var_type;

                static NovatelFRESET_Response_DataReader_ptr _duplicate (NovatelFRESET_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelFRESET_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelFRESET_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelFRESET_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelFRESET_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelFRESET_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelFRESET_Response_& instance) = 0;

            protected:
                NovatelFRESET_Response_DataReader () {};
                ~NovatelFRESET_Response_DataReader () {};
            private:
                NovatelFRESET_Response_DataReader (const NovatelFRESET_Response_DataReader &);
                NovatelFRESET_Response_DataReader & operator = (const NovatelFRESET_Response_DataReader &);
            };

            class  NovatelFRESET_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelFRESET_Response_DataReaderView_ptr _ptr_type;
                typedef NovatelFRESET_Response_DataReaderView_var _var_type;

                static NovatelFRESET_Response_DataReaderView_ptr _duplicate (NovatelFRESET_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelFRESET_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelFRESET_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelFRESET_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelFRESET_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelFRESET_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelFRESET_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelFRESET_Response_& instance) = 0;

            protected:
                NovatelFRESET_Response_DataReaderView () {};
                ~NovatelFRESET_Response_DataReaderView () {};
            private:
                NovatelFRESET_Response_DataReaderView (const NovatelFRESET_Response_DataReaderView &);
                NovatelFRESET_Response_DataReaderView & operator = (const NovatelFRESET_Response_DataReaderView &);
            };
            class Sample_NovatelFRESET_Request_TypeSupportInterface;

            typedef Sample_NovatelFRESET_Request_TypeSupportInterface * Sample_NovatelFRESET_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_NovatelFRESET_Request_TypeSupportInterface> Sample_NovatelFRESET_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_NovatelFRESET_Request_TypeSupportInterface> Sample_NovatelFRESET_Request_TypeSupportInterface_out;


            class Sample_NovatelFRESET_Request_DataWriter;

            typedef Sample_NovatelFRESET_Request_DataWriter * Sample_NovatelFRESET_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_NovatelFRESET_Request_DataWriter> Sample_NovatelFRESET_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_NovatelFRESET_Request_DataWriter> Sample_NovatelFRESET_Request_DataWriter_out;


            class Sample_NovatelFRESET_Request_DataReader;

            typedef Sample_NovatelFRESET_Request_DataReader * Sample_NovatelFRESET_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_NovatelFRESET_Request_DataReader> Sample_NovatelFRESET_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_NovatelFRESET_Request_DataReader> Sample_NovatelFRESET_Request_DataReader_out;


            class Sample_NovatelFRESET_Request_DataReaderView;

            typedef Sample_NovatelFRESET_Request_DataReaderView * Sample_NovatelFRESET_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_NovatelFRESET_Request_DataReaderView> Sample_NovatelFRESET_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_NovatelFRESET_Request_DataReaderView> Sample_NovatelFRESET_Request_DataReaderView_out;

            struct Sample_NovatelFRESET_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_NovatelFRESET_Request_, struct Sample_NovatelFRESET_Request_Seq_uniq_> Sample_NovatelFRESET_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_NovatelFRESET_Request_Seq> Sample_NovatelFRESET_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_NovatelFRESET_Request_Seq> Sample_NovatelFRESET_Request_Seq_out;

            class  Sample_NovatelFRESET_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_NovatelFRESET_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_NovatelFRESET_Request_TypeSupportInterface_var _var_type;

                static Sample_NovatelFRESET_Request_TypeSupportInterface_ptr _duplicate (Sample_NovatelFRESET_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_NovatelFRESET_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_NovatelFRESET_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_NovatelFRESET_Request_TypeSupportInterface () {};
                ~Sample_NovatelFRESET_Request_TypeSupportInterface () {};
            private:
                Sample_NovatelFRESET_Request_TypeSupportInterface (const Sample_NovatelFRESET_Request_TypeSupportInterface &);
                Sample_NovatelFRESET_Request_TypeSupportInterface & operator = (const Sample_NovatelFRESET_Request_TypeSupportInterface &);
            };

            class  Sample_NovatelFRESET_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_NovatelFRESET_Request_DataWriter_ptr _ptr_type;
                typedef Sample_NovatelFRESET_Request_DataWriter_var _var_type;

                static Sample_NovatelFRESET_Request_DataWriter_ptr _duplicate (Sample_NovatelFRESET_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_NovatelFRESET_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_NovatelFRESET_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_NovatelFRESET_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_NovatelFRESET_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_NovatelFRESET_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_NovatelFRESET_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_NovatelFRESET_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_NovatelFRESET_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_NovatelFRESET_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_NovatelFRESET_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_NovatelFRESET_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_NovatelFRESET_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_NovatelFRESET_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_NovatelFRESET_Request_& instance_data) = 0;

            protected:
                Sample_NovatelFRESET_Request_DataWriter () {};
                ~Sample_NovatelFRESET_Request_DataWriter () {};
            private:
                Sample_NovatelFRESET_Request_DataWriter (const Sample_NovatelFRESET_Request_DataWriter &);
                Sample_NovatelFRESET_Request_DataWriter & operator = (const Sample_NovatelFRESET_Request_DataWriter &);
            };

            class  Sample_NovatelFRESET_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_NovatelFRESET_Request_DataReader_ptr _ptr_type;
                typedef Sample_NovatelFRESET_Request_DataReader_var _var_type;

                static Sample_NovatelFRESET_Request_DataReader_ptr _duplicate (Sample_NovatelFRESET_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_NovatelFRESET_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_NovatelFRESET_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_NovatelFRESET_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_NovatelFRESET_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_NovatelFRESET_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_NovatelFRESET_Request_& instance) = 0;

            protected:
                Sample_NovatelFRESET_Request_DataReader () {};
                ~Sample_NovatelFRESET_Request_DataReader () {};
            private:
                Sample_NovatelFRESET_Request_DataReader (const Sample_NovatelFRESET_Request_DataReader &);
                Sample_NovatelFRESET_Request_DataReader & operator = (const Sample_NovatelFRESET_Request_DataReader &);
            };

            class  Sample_NovatelFRESET_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_NovatelFRESET_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_NovatelFRESET_Request_DataReaderView_var _var_type;

                static Sample_NovatelFRESET_Request_DataReaderView_ptr _duplicate (Sample_NovatelFRESET_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_NovatelFRESET_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_NovatelFRESET_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_NovatelFRESET_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_NovatelFRESET_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_NovatelFRESET_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_NovatelFRESET_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_NovatelFRESET_Request_& instance) = 0;

            protected:
                Sample_NovatelFRESET_Request_DataReaderView () {};
                ~Sample_NovatelFRESET_Request_DataReaderView () {};
            private:
                Sample_NovatelFRESET_Request_DataReaderView (const Sample_NovatelFRESET_Request_DataReaderView &);
                Sample_NovatelFRESET_Request_DataReaderView & operator = (const Sample_NovatelFRESET_Request_DataReaderView &);
            };
            class Sample_NovatelFRESET_Response_TypeSupportInterface;

            typedef Sample_NovatelFRESET_Response_TypeSupportInterface * Sample_NovatelFRESET_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_NovatelFRESET_Response_TypeSupportInterface> Sample_NovatelFRESET_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_NovatelFRESET_Response_TypeSupportInterface> Sample_NovatelFRESET_Response_TypeSupportInterface_out;


            class Sample_NovatelFRESET_Response_DataWriter;

            typedef Sample_NovatelFRESET_Response_DataWriter * Sample_NovatelFRESET_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_NovatelFRESET_Response_DataWriter> Sample_NovatelFRESET_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_NovatelFRESET_Response_DataWriter> Sample_NovatelFRESET_Response_DataWriter_out;


            class Sample_NovatelFRESET_Response_DataReader;

            typedef Sample_NovatelFRESET_Response_DataReader * Sample_NovatelFRESET_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_NovatelFRESET_Response_DataReader> Sample_NovatelFRESET_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_NovatelFRESET_Response_DataReader> Sample_NovatelFRESET_Response_DataReader_out;


            class Sample_NovatelFRESET_Response_DataReaderView;

            typedef Sample_NovatelFRESET_Response_DataReaderView * Sample_NovatelFRESET_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_NovatelFRESET_Response_DataReaderView> Sample_NovatelFRESET_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_NovatelFRESET_Response_DataReaderView> Sample_NovatelFRESET_Response_DataReaderView_out;

            struct Sample_NovatelFRESET_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_NovatelFRESET_Response_, struct Sample_NovatelFRESET_Response_Seq_uniq_> Sample_NovatelFRESET_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_NovatelFRESET_Response_Seq> Sample_NovatelFRESET_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_NovatelFRESET_Response_Seq> Sample_NovatelFRESET_Response_Seq_out;

            class  Sample_NovatelFRESET_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_NovatelFRESET_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_NovatelFRESET_Response_TypeSupportInterface_var _var_type;

                static Sample_NovatelFRESET_Response_TypeSupportInterface_ptr _duplicate (Sample_NovatelFRESET_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_NovatelFRESET_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_NovatelFRESET_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_NovatelFRESET_Response_TypeSupportInterface () {};
                ~Sample_NovatelFRESET_Response_TypeSupportInterface () {};
            private:
                Sample_NovatelFRESET_Response_TypeSupportInterface (const Sample_NovatelFRESET_Response_TypeSupportInterface &);
                Sample_NovatelFRESET_Response_TypeSupportInterface & operator = (const Sample_NovatelFRESET_Response_TypeSupportInterface &);
            };

            class  Sample_NovatelFRESET_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_NovatelFRESET_Response_DataWriter_ptr _ptr_type;
                typedef Sample_NovatelFRESET_Response_DataWriter_var _var_type;

                static Sample_NovatelFRESET_Response_DataWriter_ptr _duplicate (Sample_NovatelFRESET_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_NovatelFRESET_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_NovatelFRESET_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_NovatelFRESET_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_NovatelFRESET_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_NovatelFRESET_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_NovatelFRESET_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_NovatelFRESET_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_NovatelFRESET_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_NovatelFRESET_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_NovatelFRESET_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_NovatelFRESET_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_NovatelFRESET_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_NovatelFRESET_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_NovatelFRESET_Response_& instance_data) = 0;

            protected:
                Sample_NovatelFRESET_Response_DataWriter () {};
                ~Sample_NovatelFRESET_Response_DataWriter () {};
            private:
                Sample_NovatelFRESET_Response_DataWriter (const Sample_NovatelFRESET_Response_DataWriter &);
                Sample_NovatelFRESET_Response_DataWriter & operator = (const Sample_NovatelFRESET_Response_DataWriter &);
            };

            class  Sample_NovatelFRESET_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_NovatelFRESET_Response_DataReader_ptr _ptr_type;
                typedef Sample_NovatelFRESET_Response_DataReader_var _var_type;

                static Sample_NovatelFRESET_Response_DataReader_ptr _duplicate (Sample_NovatelFRESET_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_NovatelFRESET_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_NovatelFRESET_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_NovatelFRESET_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_NovatelFRESET_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_NovatelFRESET_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_NovatelFRESET_Response_& instance) = 0;

            protected:
                Sample_NovatelFRESET_Response_DataReader () {};
                ~Sample_NovatelFRESET_Response_DataReader () {};
            private:
                Sample_NovatelFRESET_Response_DataReader (const Sample_NovatelFRESET_Response_DataReader &);
                Sample_NovatelFRESET_Response_DataReader & operator = (const Sample_NovatelFRESET_Response_DataReader &);
            };

            class  Sample_NovatelFRESET_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_NovatelFRESET_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_NovatelFRESET_Response_DataReaderView_var _var_type;

                static Sample_NovatelFRESET_Response_DataReaderView_ptr _duplicate (Sample_NovatelFRESET_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_NovatelFRESET_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_NovatelFRESET_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_NovatelFRESET_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_NovatelFRESET_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_NovatelFRESET_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_NovatelFRESET_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_NovatelFRESET_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_NovatelFRESET_Response_& instance) = 0;

            protected:
                Sample_NovatelFRESET_Response_DataReaderView () {};
                ~Sample_NovatelFRESET_Response_DataReaderView () {};
            private:
                Sample_NovatelFRESET_Response_DataReaderView (const Sample_NovatelFRESET_Response_DataReaderView &);
                Sample_NovatelFRESET_Response_DataReaderView & operator = (const Sample_NovatelFRESET_Response_DataReaderView &);
            };
        }

    }

}

#endif
