#ifndef _H_25A3AB3CD8036A0845E17F18880AAA96_Gpgsv_DCPS_H_
#define _H_25A3AB3CD8036A0845E17F18880AAA96_Gpgsv_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Gpgsv_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Gpgsv_TypeSupportInterface;

            typedef Gpgsv_TypeSupportInterface * Gpgsv_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Gpgsv_TypeSupportInterface> Gpgsv_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Gpgsv_TypeSupportInterface> Gpgsv_TypeSupportInterface_out;


            class Gpgsv_DataWriter;

            typedef Gpgsv_DataWriter * Gpgsv_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Gpgsv_DataWriter> Gpgsv_DataWriter_var;
            typedef DDS_DCPSInterface_out < Gpgsv_DataWriter> Gpgsv_DataWriter_out;


            class Gpgsv_DataReader;

            typedef Gpgsv_DataReader * Gpgsv_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Gpgsv_DataReader> Gpgsv_DataReader_var;
            typedef DDS_DCPSInterface_out < Gpgsv_DataReader> Gpgsv_DataReader_out;


            class Gpgsv_DataReaderView;

            typedef Gpgsv_DataReaderView * Gpgsv_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Gpgsv_DataReaderView> Gpgsv_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Gpgsv_DataReaderView> Gpgsv_DataReaderView_out;

            struct Gpgsv_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Gpgsv_, struct Gpgsv_Seq_uniq_> Gpgsv_Seq;
            typedef DDS_DCPSSequence_var < Gpgsv_Seq> Gpgsv_Seq_var;
            typedef DDS_DCPSSequence_out < Gpgsv_Seq> Gpgsv_Seq_out;

            class  Gpgsv_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Gpgsv_TypeSupportInterface_ptr _ptr_type;
                typedef Gpgsv_TypeSupportInterface_var _var_type;

                static Gpgsv_TypeSupportInterface_ptr _duplicate (Gpgsv_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgsv_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Gpgsv_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgsv_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgsv_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Gpgsv_TypeSupportInterface () {};
                ~Gpgsv_TypeSupportInterface () {};
            private:
                Gpgsv_TypeSupportInterface (const Gpgsv_TypeSupportInterface &);
                Gpgsv_TypeSupportInterface & operator = (const Gpgsv_TypeSupportInterface &);
            };

            class  Gpgsv_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Gpgsv_DataWriter_ptr _ptr_type;
                typedef Gpgsv_DataWriter_var _var_type;

                static Gpgsv_DataWriter_ptr _duplicate (Gpgsv_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgsv_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Gpgsv_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgsv_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgsv_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Gpgsv_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Gpgsv_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Gpgsv_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Gpgsv_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Gpgsv_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Gpgsv_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Gpgsv_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Gpgsv_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Gpgsv_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Gpgsv_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Gpgsv_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgsv_& instance_data) = 0;

            protected:
                Gpgsv_DataWriter () {};
                ~Gpgsv_DataWriter () {};
            private:
                Gpgsv_DataWriter (const Gpgsv_DataWriter &);
                Gpgsv_DataWriter & operator = (const Gpgsv_DataWriter &);
            };

            class  Gpgsv_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Gpgsv_DataReader_ptr _ptr_type;
                typedef Gpgsv_DataReader_var _var_type;

                static Gpgsv_DataReader_ptr _duplicate (Gpgsv_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgsv_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Gpgsv_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgsv_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgsv_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gpgsv_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gpgsv_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gpgsv_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgsv_& instance) = 0;

            protected:
                Gpgsv_DataReader () {};
                ~Gpgsv_DataReader () {};
            private:
                Gpgsv_DataReader (const Gpgsv_DataReader &);
                Gpgsv_DataReader & operator = (const Gpgsv_DataReader &);
            };

            class  Gpgsv_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Gpgsv_DataReaderView_ptr _ptr_type;
                typedef Gpgsv_DataReaderView_var _var_type;

                static Gpgsv_DataReaderView_ptr _duplicate (Gpgsv_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgsv_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Gpgsv_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgsv_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgsv_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gpgsv_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gpgsv_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gpgsv_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gpgsv_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgsv_& instance) = 0;

            protected:
                Gpgsv_DataReaderView () {};
                ~Gpgsv_DataReaderView () {};
            private:
                Gpgsv_DataReaderView (const Gpgsv_DataReaderView &);
                Gpgsv_DataReaderView & operator = (const Gpgsv_DataReaderView &);
            };
        }

    }

}

#endif
