#ifndef _H_473F25DB7850ACFE30D88C6232879CFB_Gphdt_DCPS_H_
#define _H_473F25DB7850ACFE30D88C6232879CFB_Gphdt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Gphdt_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Gphdt_TypeSupportInterface;

            typedef Gphdt_TypeSupportInterface * Gphdt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Gphdt_TypeSupportInterface> Gphdt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Gphdt_TypeSupportInterface> Gphdt_TypeSupportInterface_out;


            class Gphdt_DataWriter;

            typedef Gphdt_DataWriter * Gphdt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Gphdt_DataWriter> Gphdt_DataWriter_var;
            typedef DDS_DCPSInterface_out < Gphdt_DataWriter> Gphdt_DataWriter_out;


            class Gphdt_DataReader;

            typedef Gphdt_DataReader * Gphdt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Gphdt_DataReader> Gphdt_DataReader_var;
            typedef DDS_DCPSInterface_out < Gphdt_DataReader> Gphdt_DataReader_out;


            class Gphdt_DataReaderView;

            typedef Gphdt_DataReaderView * Gphdt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Gphdt_DataReaderView> Gphdt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Gphdt_DataReaderView> Gphdt_DataReaderView_out;

            struct Gphdt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Gphdt_, struct Gphdt_Seq_uniq_> Gphdt_Seq;
            typedef DDS_DCPSSequence_var < Gphdt_Seq> Gphdt_Seq_var;
            typedef DDS_DCPSSequence_out < Gphdt_Seq> Gphdt_Seq_out;

            class  Gphdt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Gphdt_TypeSupportInterface_ptr _ptr_type;
                typedef Gphdt_TypeSupportInterface_var _var_type;

                static Gphdt_TypeSupportInterface_ptr _duplicate (Gphdt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gphdt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Gphdt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gphdt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Gphdt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Gphdt_TypeSupportInterface () {};
                ~Gphdt_TypeSupportInterface () {};
            private:
                Gphdt_TypeSupportInterface (const Gphdt_TypeSupportInterface &);
                Gphdt_TypeSupportInterface & operator = (const Gphdt_TypeSupportInterface &);
            };

            class  Gphdt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Gphdt_DataWriter_ptr _ptr_type;
                typedef Gphdt_DataWriter_var _var_type;

                static Gphdt_DataWriter_ptr _duplicate (Gphdt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gphdt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Gphdt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gphdt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Gphdt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Gphdt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Gphdt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Gphdt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Gphdt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Gphdt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Gphdt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Gphdt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Gphdt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Gphdt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Gphdt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Gphdt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gphdt_& instance_data) = 0;

            protected:
                Gphdt_DataWriter () {};
                ~Gphdt_DataWriter () {};
            private:
                Gphdt_DataWriter (const Gphdt_DataWriter &);
                Gphdt_DataWriter & operator = (const Gphdt_DataWriter &);
            };

            class  Gphdt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Gphdt_DataReader_ptr _ptr_type;
                typedef Gphdt_DataReader_var _var_type;

                static Gphdt_DataReader_ptr _duplicate (Gphdt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gphdt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Gphdt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gphdt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Gphdt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gphdt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gphdt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gphdt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gphdt_& instance) = 0;

            protected:
                Gphdt_DataReader () {};
                ~Gphdt_DataReader () {};
            private:
                Gphdt_DataReader (const Gphdt_DataReader &);
                Gphdt_DataReader & operator = (const Gphdt_DataReader &);
            };

            class  Gphdt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Gphdt_DataReaderView_ptr _ptr_type;
                typedef Gphdt_DataReaderView_var _var_type;

                static Gphdt_DataReaderView_ptr _duplicate (Gphdt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gphdt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Gphdt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gphdt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Gphdt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gphdt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gphdt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gphdt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gphdt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gphdt_& instance) = 0;

            protected:
                Gphdt_DataReaderView () {};
                ~Gphdt_DataReaderView () {};
            private:
                Gphdt_DataReaderView (const Gphdt_DataReaderView &);
                Gphdt_DataReaderView & operator = (const Gphdt_DataReaderView &);
            };
        }

    }

}

#endif
