#ifndef _H_FC0217CD8674CEC57BBAAF58E70D6115_Inspva__H_
#define _H_FC0217CD8674CEC57BBAAF58E70D6115_Inspva__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Inspva_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::ULong week_;
                ::DDS::Double seconds_;
                ::DDS::Double latitude_;
                ::DDS::Double longitude_;
                ::DDS::Double height_;
                ::DDS::Double north_velocity_;
                ::DDS::Double east_velocity_;
                ::DDS::Double up_velocity_;
                ::DDS::Double roll_;
                ::DDS::Double pitch_;
                ::DDS::Double azimuth_;
                ::DDS::String_mgr status_;
            };

            typedef DDS_DCPSStruct_var<Inspva_> Inspva__var;
            typedef DDS_DCPSStruct_out < Inspva_> Inspva__out;

        }

    }

}

#endif /* _H_FC0217CD8674CEC57BBAAF58E70D6115_Inspva__H_ */
