#ifndef _H_FC0217CD8674CEC57BBAAF58E70D6115_Inspva_DCPS_H_
#define _H_FC0217CD8674CEC57BBAAF58E70D6115_Inspva_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Inspva_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Inspva_TypeSupportInterface;

            typedef Inspva_TypeSupportInterface * Inspva_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Inspva_TypeSupportInterface> Inspva_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Inspva_TypeSupportInterface> Inspva_TypeSupportInterface_out;


            class Inspva_DataWriter;

            typedef Inspva_DataWriter * Inspva_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Inspva_DataWriter> Inspva_DataWriter_var;
            typedef DDS_DCPSInterface_out < Inspva_DataWriter> Inspva_DataWriter_out;


            class Inspva_DataReader;

            typedef Inspva_DataReader * Inspva_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Inspva_DataReader> Inspva_DataReader_var;
            typedef DDS_DCPSInterface_out < Inspva_DataReader> Inspva_DataReader_out;


            class Inspva_DataReaderView;

            typedef Inspva_DataReaderView * Inspva_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Inspva_DataReaderView> Inspva_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Inspva_DataReaderView> Inspva_DataReaderView_out;

            struct Inspva_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Inspva_, struct Inspva_Seq_uniq_> Inspva_Seq;
            typedef DDS_DCPSSequence_var < Inspva_Seq> Inspva_Seq_var;
            typedef DDS_DCPSSequence_out < Inspva_Seq> Inspva_Seq_out;

            class  Inspva_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Inspva_TypeSupportInterface_ptr _ptr_type;
                typedef Inspva_TypeSupportInterface_var _var_type;

                static Inspva_TypeSupportInterface_ptr _duplicate (Inspva_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inspva_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Inspva_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inspva_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Inspva_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Inspva_TypeSupportInterface () {};
                ~Inspva_TypeSupportInterface () {};
            private:
                Inspva_TypeSupportInterface (const Inspva_TypeSupportInterface &);
                Inspva_TypeSupportInterface & operator = (const Inspva_TypeSupportInterface &);
            };

            class  Inspva_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Inspva_DataWriter_ptr _ptr_type;
                typedef Inspva_DataWriter_var _var_type;

                static Inspva_DataWriter_ptr _duplicate (Inspva_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inspva_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Inspva_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inspva_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Inspva_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Inspva_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Inspva_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Inspva_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Inspva_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Inspva_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Inspva_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Inspva_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Inspva_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Inspva_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Inspva_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Inspva_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inspva_& instance_data) = 0;

            protected:
                Inspva_DataWriter () {};
                ~Inspva_DataWriter () {};
            private:
                Inspva_DataWriter (const Inspva_DataWriter &);
                Inspva_DataWriter & operator = (const Inspva_DataWriter &);
            };

            class  Inspva_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Inspva_DataReader_ptr _ptr_type;
                typedef Inspva_DataReader_var _var_type;

                static Inspva_DataReader_ptr _duplicate (Inspva_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inspva_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Inspva_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inspva_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Inspva_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Inspva_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Inspva_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Inspva_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inspva_& instance) = 0;

            protected:
                Inspva_DataReader () {};
                ~Inspva_DataReader () {};
            private:
                Inspva_DataReader (const Inspva_DataReader &);
                Inspva_DataReader & operator = (const Inspva_DataReader &);
            };

            class  Inspva_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Inspva_DataReaderView_ptr _ptr_type;
                typedef Inspva_DataReaderView_var _var_type;

                static Inspva_DataReaderView_ptr _duplicate (Inspva_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inspva_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Inspva_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inspva_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Inspva_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Inspva_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Inspva_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Inspva_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Inspva_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inspva_& instance) = 0;

            protected:
                Inspva_DataReaderView () {};
                ~Inspva_DataReaderView () {};
            private:
                Inspva_DataReaderView (const Inspva_DataReaderView &);
                Inspva_DataReaderView & operator = (const Inspva_DataReaderView &);
            };
        }

    }

}

#endif
