#ifndef _H_D48BAD9597CA82038872148EEEBFD928_Inspvax_DCPS_H_
#define _H_D48BAD9597CA82038872148EEEBFD928_Inspvax_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Inspvax_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Inspvax_TypeSupportInterface;

            typedef Inspvax_TypeSupportInterface * Inspvax_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Inspvax_TypeSupportInterface> Inspvax_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Inspvax_TypeSupportInterface> Inspvax_TypeSupportInterface_out;


            class Inspvax_DataWriter;

            typedef Inspvax_DataWriter * Inspvax_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Inspvax_DataWriter> Inspvax_DataWriter_var;
            typedef DDS_DCPSInterface_out < Inspvax_DataWriter> Inspvax_DataWriter_out;


            class Inspvax_DataReader;

            typedef Inspvax_DataReader * Inspvax_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Inspvax_DataReader> Inspvax_DataReader_var;
            typedef DDS_DCPSInterface_out < Inspvax_DataReader> Inspvax_DataReader_out;


            class Inspvax_DataReaderView;

            typedef Inspvax_DataReaderView * Inspvax_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Inspvax_DataReaderView> Inspvax_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Inspvax_DataReaderView> Inspvax_DataReaderView_out;

            struct Inspvax_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Inspvax_, struct Inspvax_Seq_uniq_> Inspvax_Seq;
            typedef DDS_DCPSSequence_var < Inspvax_Seq> Inspvax_Seq_var;
            typedef DDS_DCPSSequence_out < Inspvax_Seq> Inspvax_Seq_out;

            class  Inspvax_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Inspvax_TypeSupportInterface_ptr _ptr_type;
                typedef Inspvax_TypeSupportInterface_var _var_type;

                static Inspvax_TypeSupportInterface_ptr _duplicate (Inspvax_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inspvax_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Inspvax_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inspvax_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Inspvax_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Inspvax_TypeSupportInterface () {};
                ~Inspvax_TypeSupportInterface () {};
            private:
                Inspvax_TypeSupportInterface (const Inspvax_TypeSupportInterface &);
                Inspvax_TypeSupportInterface & operator = (const Inspvax_TypeSupportInterface &);
            };

            class  Inspvax_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Inspvax_DataWriter_ptr _ptr_type;
                typedef Inspvax_DataWriter_var _var_type;

                static Inspvax_DataWriter_ptr _duplicate (Inspvax_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inspvax_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Inspvax_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inspvax_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Inspvax_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Inspvax_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Inspvax_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Inspvax_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Inspvax_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Inspvax_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Inspvax_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Inspvax_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Inspvax_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Inspvax_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Inspvax_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Inspvax_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inspvax_& instance_data) = 0;

            protected:
                Inspvax_DataWriter () {};
                ~Inspvax_DataWriter () {};
            private:
                Inspvax_DataWriter (const Inspvax_DataWriter &);
                Inspvax_DataWriter & operator = (const Inspvax_DataWriter &);
            };

            class  Inspvax_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Inspvax_DataReader_ptr _ptr_type;
                typedef Inspvax_DataReader_var _var_type;

                static Inspvax_DataReader_ptr _duplicate (Inspvax_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inspvax_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Inspvax_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inspvax_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Inspvax_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Inspvax_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Inspvax_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Inspvax_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inspvax_& instance) = 0;

            protected:
                Inspvax_DataReader () {};
                ~Inspvax_DataReader () {};
            private:
                Inspvax_DataReader (const Inspvax_DataReader &);
                Inspvax_DataReader & operator = (const Inspvax_DataReader &);
            };

            class  Inspvax_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Inspvax_DataReaderView_ptr _ptr_type;
                typedef Inspvax_DataReaderView_var _var_type;

                static Inspvax_DataReaderView_ptr _duplicate (Inspvax_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Inspvax_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Inspvax_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Inspvax_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Inspvax_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Inspvax_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Inspvax_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Inspvax_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Inspvax_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Inspvax_& instance) = 0;

            protected:
                Inspvax_DataReaderView () {};
                ~Inspvax_DataReaderView () {};
            private:
                Inspvax_DataReaderView (const Inspvax_DataReaderView &);
                Inspvax_DataReaderView & operator = (const Inspvax_DataReaderView &);
            };
        }

    }

}

#endif
