#ifndef _H_8A6F3AD086AF5A213670D3672C6F9422_Insstdev__H_
#define _H_8A6F3AD086AF5A213670D3672C6F9422_Insstdev__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelExtendedSolutionStatus_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Insstdev_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::Float latitude_dev_;
                ::DDS::Float longitude_dev_;
                ::DDS::Float height_dev_;
                ::DDS::Float north_velocity_dev_;
                ::DDS::Float east_velocity_dev_;
                ::DDS::Float up_velocity_dev_;
                ::DDS::Float roll_dev_;
                ::DDS::Float pitch_dev_;
                ::DDS::Float azimuth_dev_;
                ::novatel_gps_msgs::msg::dds_::NovatelExtendedSolutionStatus_ extended_solution_status_;
                ::DDS::UShort time_since_update_;
            };

            typedef DDS_DCPSStruct_var<Insstdev_> Insstdev__var;
            typedef DDS_DCPSStruct_out < Insstdev_> Insstdev__out;

        }

    }

}

#endif /* _H_8A6F3AD086AF5A213670D3672C6F9422_Insstdev__H_ */
