#ifndef _H_8A6F3AD086AF5A213670D3672C6F9422_Insstdev_DCPS_H_
#define _H_8A6F3AD086AF5A213670D3672C6F9422_Insstdev_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Insstdev_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Insstdev_TypeSupportInterface;

            typedef Insstdev_TypeSupportInterface * Insstdev_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Insstdev_TypeSupportInterface> Insstdev_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Insstdev_TypeSupportInterface> Insstdev_TypeSupportInterface_out;


            class Insstdev_DataWriter;

            typedef Insstdev_DataWriter * Insstdev_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Insstdev_DataWriter> Insstdev_DataWriter_var;
            typedef DDS_DCPSInterface_out < Insstdev_DataWriter> Insstdev_DataWriter_out;


            class Insstdev_DataReader;

            typedef Insstdev_DataReader * Insstdev_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Insstdev_DataReader> Insstdev_DataReader_var;
            typedef DDS_DCPSInterface_out < Insstdev_DataReader> Insstdev_DataReader_out;


            class Insstdev_DataReaderView;

            typedef Insstdev_DataReaderView * Insstdev_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Insstdev_DataReaderView> Insstdev_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Insstdev_DataReaderView> Insstdev_DataReaderView_out;

            struct Insstdev_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Insstdev_, struct Insstdev_Seq_uniq_> Insstdev_Seq;
            typedef DDS_DCPSSequence_var < Insstdev_Seq> Insstdev_Seq_var;
            typedef DDS_DCPSSequence_out < Insstdev_Seq> Insstdev_Seq_out;

            class  Insstdev_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Insstdev_TypeSupportInterface_ptr _ptr_type;
                typedef Insstdev_TypeSupportInterface_var _var_type;

                static Insstdev_TypeSupportInterface_ptr _duplicate (Insstdev_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Insstdev_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Insstdev_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Insstdev_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Insstdev_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Insstdev_TypeSupportInterface () {};
                ~Insstdev_TypeSupportInterface () {};
            private:
                Insstdev_TypeSupportInterface (const Insstdev_TypeSupportInterface &);
                Insstdev_TypeSupportInterface & operator = (const Insstdev_TypeSupportInterface &);
            };

            class  Insstdev_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Insstdev_DataWriter_ptr _ptr_type;
                typedef Insstdev_DataWriter_var _var_type;

                static Insstdev_DataWriter_ptr _duplicate (Insstdev_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Insstdev_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Insstdev_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Insstdev_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Insstdev_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Insstdev_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Insstdev_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Insstdev_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Insstdev_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Insstdev_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Insstdev_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Insstdev_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Insstdev_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Insstdev_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Insstdev_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Insstdev_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Insstdev_& instance_data) = 0;

            protected:
                Insstdev_DataWriter () {};
                ~Insstdev_DataWriter () {};
            private:
                Insstdev_DataWriter (const Insstdev_DataWriter &);
                Insstdev_DataWriter & operator = (const Insstdev_DataWriter &);
            };

            class  Insstdev_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Insstdev_DataReader_ptr _ptr_type;
                typedef Insstdev_DataReader_var _var_type;

                static Insstdev_DataReader_ptr _duplicate (Insstdev_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Insstdev_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Insstdev_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Insstdev_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Insstdev_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Insstdev_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Insstdev_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Insstdev_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Insstdev_& instance) = 0;

            protected:
                Insstdev_DataReader () {};
                ~Insstdev_DataReader () {};
            private:
                Insstdev_DataReader (const Insstdev_DataReader &);
                Insstdev_DataReader & operator = (const Insstdev_DataReader &);
            };

            class  Insstdev_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Insstdev_DataReaderView_ptr _ptr_type;
                typedef Insstdev_DataReaderView_var _var_type;

                static Insstdev_DataReaderView_ptr _duplicate (Insstdev_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Insstdev_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Insstdev_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Insstdev_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Insstdev_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Insstdev_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Insstdev_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Insstdev_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Insstdev_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Insstdev_& instance) = 0;

            protected:
                Insstdev_DataReaderView () {};
                ~Insstdev_DataReaderView () {};
            private:
                Insstdev_DataReaderView (const Insstdev_DataReaderView &);
                Insstdev_DataReaderView & operator = (const Insstdev_DataReaderView &);
            };
        }

    }

}

#endif
