#ifndef _H_D1EBC56005369551D54316CA43E37F43_NovatelCorrectedImuData__H_
#define _H_D1EBC56005369551D54316CA43E37F43_NovatelCorrectedImuData__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  NovatelCorrectedImuData_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::ULong gps_week_num_;
                ::DDS::Double gps_seconds_;
                ::DDS::Double pitch_rate_;
                ::DDS::Double roll_rate_;
                ::DDS::Double yaw_rate_;
                ::DDS::Double lateral_acceleration_;
                ::DDS::Double longitudinal_acceleration_;
                ::DDS::Double vertical_acceleration_;
            };

            typedef DDS_DCPSStruct_var<NovatelCorrectedImuData_> NovatelCorrectedImuData__var;
            typedef DDS_DCPSStruct_out < NovatelCorrectedImuData_> NovatelCorrectedImuData__out;

        }

    }

}

#endif /* _H_D1EBC56005369551D54316CA43E37F43_NovatelCorrectedImuData__H_ */
