#ifndef _H_BC4D5E0F5C973E7C59A2F37AB7414725_NovatelDualAntennaHeading_DCPS_H_
#define _H_BC4D5E0F5C973E7C59A2F37AB7414725_NovatelDualAntennaHeading_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelDualAntennaHeading_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelDualAntennaHeading_TypeSupportInterface;

            typedef NovatelDualAntennaHeading_TypeSupportInterface * NovatelDualAntennaHeading_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelDualAntennaHeading_TypeSupportInterface> NovatelDualAntennaHeading_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelDualAntennaHeading_TypeSupportInterface> NovatelDualAntennaHeading_TypeSupportInterface_out;


            class NovatelDualAntennaHeading_DataWriter;

            typedef NovatelDualAntennaHeading_DataWriter * NovatelDualAntennaHeading_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelDualAntennaHeading_DataWriter> NovatelDualAntennaHeading_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelDualAntennaHeading_DataWriter> NovatelDualAntennaHeading_DataWriter_out;


            class NovatelDualAntennaHeading_DataReader;

            typedef NovatelDualAntennaHeading_DataReader * NovatelDualAntennaHeading_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelDualAntennaHeading_DataReader> NovatelDualAntennaHeading_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelDualAntennaHeading_DataReader> NovatelDualAntennaHeading_DataReader_out;


            class NovatelDualAntennaHeading_DataReaderView;

            typedef NovatelDualAntennaHeading_DataReaderView * NovatelDualAntennaHeading_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelDualAntennaHeading_DataReaderView> NovatelDualAntennaHeading_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelDualAntennaHeading_DataReaderView> NovatelDualAntennaHeading_DataReaderView_out;

            struct NovatelDualAntennaHeading_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelDualAntennaHeading_, struct NovatelDualAntennaHeading_Seq_uniq_> NovatelDualAntennaHeading_Seq;
            typedef DDS_DCPSSequence_var < NovatelDualAntennaHeading_Seq> NovatelDualAntennaHeading_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelDualAntennaHeading_Seq> NovatelDualAntennaHeading_Seq_out;

            class  NovatelDualAntennaHeading_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelDualAntennaHeading_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelDualAntennaHeading_TypeSupportInterface_var _var_type;

                static NovatelDualAntennaHeading_TypeSupportInterface_ptr _duplicate (NovatelDualAntennaHeading_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelDualAntennaHeading_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelDualAntennaHeading_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelDualAntennaHeading_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelDualAntennaHeading_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelDualAntennaHeading_TypeSupportInterface () {};
                ~NovatelDualAntennaHeading_TypeSupportInterface () {};
            private:
                NovatelDualAntennaHeading_TypeSupportInterface (const NovatelDualAntennaHeading_TypeSupportInterface &);
                NovatelDualAntennaHeading_TypeSupportInterface & operator = (const NovatelDualAntennaHeading_TypeSupportInterface &);
            };

            class  NovatelDualAntennaHeading_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelDualAntennaHeading_DataWriter_ptr _ptr_type;
                typedef NovatelDualAntennaHeading_DataWriter_var _var_type;

                static NovatelDualAntennaHeading_DataWriter_ptr _duplicate (NovatelDualAntennaHeading_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelDualAntennaHeading_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelDualAntennaHeading_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelDualAntennaHeading_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelDualAntennaHeading_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelDualAntennaHeading_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelDualAntennaHeading_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelDualAntennaHeading_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelDualAntennaHeading_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelDualAntennaHeading_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelDualAntennaHeading_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelDualAntennaHeading_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelDualAntennaHeading_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelDualAntennaHeading_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelDualAntennaHeading_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelDualAntennaHeading_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelDualAntennaHeading_& instance_data) = 0;

            protected:
                NovatelDualAntennaHeading_DataWriter () {};
                ~NovatelDualAntennaHeading_DataWriter () {};
            private:
                NovatelDualAntennaHeading_DataWriter (const NovatelDualAntennaHeading_DataWriter &);
                NovatelDualAntennaHeading_DataWriter & operator = (const NovatelDualAntennaHeading_DataWriter &);
            };

            class  NovatelDualAntennaHeading_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelDualAntennaHeading_DataReader_ptr _ptr_type;
                typedef NovatelDualAntennaHeading_DataReader_var _var_type;

                static NovatelDualAntennaHeading_DataReader_ptr _duplicate (NovatelDualAntennaHeading_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelDualAntennaHeading_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelDualAntennaHeading_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelDualAntennaHeading_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelDualAntennaHeading_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelDualAntennaHeading_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelDualAntennaHeading_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelDualAntennaHeading_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelDualAntennaHeading_& instance) = 0;

            protected:
                NovatelDualAntennaHeading_DataReader () {};
                ~NovatelDualAntennaHeading_DataReader () {};
            private:
                NovatelDualAntennaHeading_DataReader (const NovatelDualAntennaHeading_DataReader &);
                NovatelDualAntennaHeading_DataReader & operator = (const NovatelDualAntennaHeading_DataReader &);
            };

            class  NovatelDualAntennaHeading_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelDualAntennaHeading_DataReaderView_ptr _ptr_type;
                typedef NovatelDualAntennaHeading_DataReaderView_var _var_type;

                static NovatelDualAntennaHeading_DataReaderView_ptr _duplicate (NovatelDualAntennaHeading_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelDualAntennaHeading_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelDualAntennaHeading_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelDualAntennaHeading_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelDualAntennaHeading_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelDualAntennaHeading_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelDualAntennaHeading_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelDualAntennaHeading_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelDualAntennaHeading_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelDualAntennaHeading_& instance) = 0;

            protected:
                NovatelDualAntennaHeading_DataReaderView () {};
                ~NovatelDualAntennaHeading_DataReaderView () {};
            private:
                NovatelDualAntennaHeading_DataReaderView (const NovatelDualAntennaHeading_DataReaderView &);
                NovatelDualAntennaHeading_DataReaderView & operator = (const NovatelDualAntennaHeading_DataReaderView &);
            };
        }

    }

}

#endif
