#ifndef _H_34D770DC538F6CFF2DCEE43D5276D5E5_NovatelExtendedSolutionStatus_DCPS_H_
#define _H_34D770DC538F6CFF2DCEE43D5276D5E5_NovatelExtendedSolutionStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelExtendedSolutionStatus_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelExtendedSolutionStatus_TypeSupportInterface;

            typedef NovatelExtendedSolutionStatus_TypeSupportInterface * NovatelExtendedSolutionStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelExtendedSolutionStatus_TypeSupportInterface> NovatelExtendedSolutionStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelExtendedSolutionStatus_TypeSupportInterface> NovatelExtendedSolutionStatus_TypeSupportInterface_out;


            class NovatelExtendedSolutionStatus_DataWriter;

            typedef NovatelExtendedSolutionStatus_DataWriter * NovatelExtendedSolutionStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelExtendedSolutionStatus_DataWriter> NovatelExtendedSolutionStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelExtendedSolutionStatus_DataWriter> NovatelExtendedSolutionStatus_DataWriter_out;


            class NovatelExtendedSolutionStatus_DataReader;

            typedef NovatelExtendedSolutionStatus_DataReader * NovatelExtendedSolutionStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelExtendedSolutionStatus_DataReader> NovatelExtendedSolutionStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelExtendedSolutionStatus_DataReader> NovatelExtendedSolutionStatus_DataReader_out;


            class NovatelExtendedSolutionStatus_DataReaderView;

            typedef NovatelExtendedSolutionStatus_DataReaderView * NovatelExtendedSolutionStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelExtendedSolutionStatus_DataReaderView> NovatelExtendedSolutionStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelExtendedSolutionStatus_DataReaderView> NovatelExtendedSolutionStatus_DataReaderView_out;

            struct NovatelExtendedSolutionStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelExtendedSolutionStatus_, struct NovatelExtendedSolutionStatus_Seq_uniq_> NovatelExtendedSolutionStatus_Seq;
            typedef DDS_DCPSSequence_var < NovatelExtendedSolutionStatus_Seq> NovatelExtendedSolutionStatus_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelExtendedSolutionStatus_Seq> NovatelExtendedSolutionStatus_Seq_out;

            class  NovatelExtendedSolutionStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelExtendedSolutionStatus_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelExtendedSolutionStatus_TypeSupportInterface_var _var_type;

                static NovatelExtendedSolutionStatus_TypeSupportInterface_ptr _duplicate (NovatelExtendedSolutionStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelExtendedSolutionStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelExtendedSolutionStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelExtendedSolutionStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelExtendedSolutionStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelExtendedSolutionStatus_TypeSupportInterface () {};
                ~NovatelExtendedSolutionStatus_TypeSupportInterface () {};
            private:
                NovatelExtendedSolutionStatus_TypeSupportInterface (const NovatelExtendedSolutionStatus_TypeSupportInterface &);
                NovatelExtendedSolutionStatus_TypeSupportInterface & operator = (const NovatelExtendedSolutionStatus_TypeSupportInterface &);
            };

            class  NovatelExtendedSolutionStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelExtendedSolutionStatus_DataWriter_ptr _ptr_type;
                typedef NovatelExtendedSolutionStatus_DataWriter_var _var_type;

                static NovatelExtendedSolutionStatus_DataWriter_ptr _duplicate (NovatelExtendedSolutionStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelExtendedSolutionStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelExtendedSolutionStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelExtendedSolutionStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelExtendedSolutionStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelExtendedSolutionStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelExtendedSolutionStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelExtendedSolutionStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelExtendedSolutionStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelExtendedSolutionStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelExtendedSolutionStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelExtendedSolutionStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelExtendedSolutionStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelExtendedSolutionStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelExtendedSolutionStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelExtendedSolutionStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelExtendedSolutionStatus_& instance_data) = 0;

            protected:
                NovatelExtendedSolutionStatus_DataWriter () {};
                ~NovatelExtendedSolutionStatus_DataWriter () {};
            private:
                NovatelExtendedSolutionStatus_DataWriter (const NovatelExtendedSolutionStatus_DataWriter &);
                NovatelExtendedSolutionStatus_DataWriter & operator = (const NovatelExtendedSolutionStatus_DataWriter &);
            };

            class  NovatelExtendedSolutionStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelExtendedSolutionStatus_DataReader_ptr _ptr_type;
                typedef NovatelExtendedSolutionStatus_DataReader_var _var_type;

                static NovatelExtendedSolutionStatus_DataReader_ptr _duplicate (NovatelExtendedSolutionStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelExtendedSolutionStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelExtendedSolutionStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelExtendedSolutionStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelExtendedSolutionStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelExtendedSolutionStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelExtendedSolutionStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelExtendedSolutionStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelExtendedSolutionStatus_& instance) = 0;

            protected:
                NovatelExtendedSolutionStatus_DataReader () {};
                ~NovatelExtendedSolutionStatus_DataReader () {};
            private:
                NovatelExtendedSolutionStatus_DataReader (const NovatelExtendedSolutionStatus_DataReader &);
                NovatelExtendedSolutionStatus_DataReader & operator = (const NovatelExtendedSolutionStatus_DataReader &);
            };

            class  NovatelExtendedSolutionStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelExtendedSolutionStatus_DataReaderView_ptr _ptr_type;
                typedef NovatelExtendedSolutionStatus_DataReaderView_var _var_type;

                static NovatelExtendedSolutionStatus_DataReaderView_ptr _duplicate (NovatelExtendedSolutionStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelExtendedSolutionStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelExtendedSolutionStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelExtendedSolutionStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelExtendedSolutionStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelExtendedSolutionStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelExtendedSolutionStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelExtendedSolutionStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelExtendedSolutionStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelExtendedSolutionStatus_& instance) = 0;

            protected:
                NovatelExtendedSolutionStatus_DataReaderView () {};
                ~NovatelExtendedSolutionStatus_DataReaderView () {};
            private:
                NovatelExtendedSolutionStatus_DataReaderView (const NovatelExtendedSolutionStatus_DataReaderView &);
                NovatelExtendedSolutionStatus_DataReaderView & operator = (const NovatelExtendedSolutionStatus_DataReaderView &);
            };
        }

    }

}

#endif
