#ifndef _H_869F60F36E382DBBDF09A0CB43D8BD34_NovatelMessageHeader_DCPS_H_
#define _H_869F60F36E382DBBDF09A0CB43D8BD34_NovatelMessageHeader_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelMessageHeader_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelMessageHeader_TypeSupportInterface;

            typedef NovatelMessageHeader_TypeSupportInterface * NovatelMessageHeader_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelMessageHeader_TypeSupportInterface> NovatelMessageHeader_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelMessageHeader_TypeSupportInterface> NovatelMessageHeader_TypeSupportInterface_out;


            class NovatelMessageHeader_DataWriter;

            typedef NovatelMessageHeader_DataWriter * NovatelMessageHeader_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelMessageHeader_DataWriter> NovatelMessageHeader_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelMessageHeader_DataWriter> NovatelMessageHeader_DataWriter_out;


            class NovatelMessageHeader_DataReader;

            typedef NovatelMessageHeader_DataReader * NovatelMessageHeader_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelMessageHeader_DataReader> NovatelMessageHeader_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelMessageHeader_DataReader> NovatelMessageHeader_DataReader_out;


            class NovatelMessageHeader_DataReaderView;

            typedef NovatelMessageHeader_DataReaderView * NovatelMessageHeader_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelMessageHeader_DataReaderView> NovatelMessageHeader_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelMessageHeader_DataReaderView> NovatelMessageHeader_DataReaderView_out;

            struct NovatelMessageHeader_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelMessageHeader_, struct NovatelMessageHeader_Seq_uniq_> NovatelMessageHeader_Seq;
            typedef DDS_DCPSSequence_var < NovatelMessageHeader_Seq> NovatelMessageHeader_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelMessageHeader_Seq> NovatelMessageHeader_Seq_out;

            class  NovatelMessageHeader_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelMessageHeader_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelMessageHeader_TypeSupportInterface_var _var_type;

                static NovatelMessageHeader_TypeSupportInterface_ptr _duplicate (NovatelMessageHeader_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelMessageHeader_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelMessageHeader_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelMessageHeader_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelMessageHeader_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelMessageHeader_TypeSupportInterface () {};
                ~NovatelMessageHeader_TypeSupportInterface () {};
            private:
                NovatelMessageHeader_TypeSupportInterface (const NovatelMessageHeader_TypeSupportInterface &);
                NovatelMessageHeader_TypeSupportInterface & operator = (const NovatelMessageHeader_TypeSupportInterface &);
            };

            class  NovatelMessageHeader_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelMessageHeader_DataWriter_ptr _ptr_type;
                typedef NovatelMessageHeader_DataWriter_var _var_type;

                static NovatelMessageHeader_DataWriter_ptr _duplicate (NovatelMessageHeader_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelMessageHeader_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelMessageHeader_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelMessageHeader_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelMessageHeader_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelMessageHeader_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelMessageHeader_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelMessageHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelMessageHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelMessageHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelMessageHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelMessageHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelMessageHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelMessageHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelMessageHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelMessageHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelMessageHeader_& instance_data) = 0;

            protected:
                NovatelMessageHeader_DataWriter () {};
                ~NovatelMessageHeader_DataWriter () {};
            private:
                NovatelMessageHeader_DataWriter (const NovatelMessageHeader_DataWriter &);
                NovatelMessageHeader_DataWriter & operator = (const NovatelMessageHeader_DataWriter &);
            };

            class  NovatelMessageHeader_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelMessageHeader_DataReader_ptr _ptr_type;
                typedef NovatelMessageHeader_DataReader_var _var_type;

                static NovatelMessageHeader_DataReader_ptr _duplicate (NovatelMessageHeader_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelMessageHeader_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelMessageHeader_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelMessageHeader_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelMessageHeader_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelMessageHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelMessageHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelMessageHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelMessageHeader_& instance) = 0;

            protected:
                NovatelMessageHeader_DataReader () {};
                ~NovatelMessageHeader_DataReader () {};
            private:
                NovatelMessageHeader_DataReader (const NovatelMessageHeader_DataReader &);
                NovatelMessageHeader_DataReader & operator = (const NovatelMessageHeader_DataReader &);
            };

            class  NovatelMessageHeader_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelMessageHeader_DataReaderView_ptr _ptr_type;
                typedef NovatelMessageHeader_DataReaderView_var _var_type;

                static NovatelMessageHeader_DataReaderView_ptr _duplicate (NovatelMessageHeader_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelMessageHeader_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelMessageHeader_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelMessageHeader_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelMessageHeader_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelMessageHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelMessageHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelMessageHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelMessageHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelMessageHeader_& instance) = 0;

            protected:
                NovatelMessageHeader_DataReaderView () {};
                ~NovatelMessageHeader_DataReaderView () {};
            private:
                NovatelMessageHeader_DataReaderView (const NovatelMessageHeader_DataReaderView &);
                NovatelMessageHeader_DataReaderView & operator = (const NovatelMessageHeader_DataReaderView &);
            };
        }

    }

}

#endif
