#ifndef _H_054BAB7E56B335D814C1C62295F675AF_NovatelReceiverStatus_DCPS_H_
#define _H_054BAB7E56B335D814C1C62295F675AF_NovatelReceiverStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelReceiverStatus_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelReceiverStatus_TypeSupportInterface;

            typedef NovatelReceiverStatus_TypeSupportInterface * NovatelReceiverStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelReceiverStatus_TypeSupportInterface> NovatelReceiverStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelReceiverStatus_TypeSupportInterface> NovatelReceiverStatus_TypeSupportInterface_out;


            class NovatelReceiverStatus_DataWriter;

            typedef NovatelReceiverStatus_DataWriter * NovatelReceiverStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelReceiverStatus_DataWriter> NovatelReceiverStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelReceiverStatus_DataWriter> NovatelReceiverStatus_DataWriter_out;


            class NovatelReceiverStatus_DataReader;

            typedef NovatelReceiverStatus_DataReader * NovatelReceiverStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelReceiverStatus_DataReader> NovatelReceiverStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelReceiverStatus_DataReader> NovatelReceiverStatus_DataReader_out;


            class NovatelReceiverStatus_DataReaderView;

            typedef NovatelReceiverStatus_DataReaderView * NovatelReceiverStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelReceiverStatus_DataReaderView> NovatelReceiverStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelReceiverStatus_DataReaderView> NovatelReceiverStatus_DataReaderView_out;

            struct NovatelReceiverStatus_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < NovatelReceiverStatus_, struct NovatelReceiverStatus_Seq_uniq_> NovatelReceiverStatus_Seq;
            typedef DDS_DCPSSequence_var < NovatelReceiverStatus_Seq> NovatelReceiverStatus_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelReceiverStatus_Seq> NovatelReceiverStatus_Seq_out;

            class  NovatelReceiverStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelReceiverStatus_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelReceiverStatus_TypeSupportInterface_var _var_type;

                static NovatelReceiverStatus_TypeSupportInterface_ptr _duplicate (NovatelReceiverStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelReceiverStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelReceiverStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelReceiverStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelReceiverStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelReceiverStatus_TypeSupportInterface () {};
                ~NovatelReceiverStatus_TypeSupportInterface () {};
            private:
                NovatelReceiverStatus_TypeSupportInterface (const NovatelReceiverStatus_TypeSupportInterface &);
                NovatelReceiverStatus_TypeSupportInterface & operator = (const NovatelReceiverStatus_TypeSupportInterface &);
            };

            class  NovatelReceiverStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelReceiverStatus_DataWriter_ptr _ptr_type;
                typedef NovatelReceiverStatus_DataWriter_var _var_type;

                static NovatelReceiverStatus_DataWriter_ptr _duplicate (NovatelReceiverStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelReceiverStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelReceiverStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelReceiverStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelReceiverStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelReceiverStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelReceiverStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelReceiverStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelReceiverStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelReceiverStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelReceiverStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelReceiverStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelReceiverStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelReceiverStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelReceiverStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelReceiverStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelReceiverStatus_& instance_data) = 0;

            protected:
                NovatelReceiverStatus_DataWriter () {};
                ~NovatelReceiverStatus_DataWriter () {};
            private:
                NovatelReceiverStatus_DataWriter (const NovatelReceiverStatus_DataWriter &);
                NovatelReceiverStatus_DataWriter & operator = (const NovatelReceiverStatus_DataWriter &);
            };

            class  NovatelReceiverStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelReceiverStatus_DataReader_ptr _ptr_type;
                typedef NovatelReceiverStatus_DataReader_var _var_type;

                static NovatelReceiverStatus_DataReader_ptr _duplicate (NovatelReceiverStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelReceiverStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelReceiverStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelReceiverStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelReceiverStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelReceiverStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelReceiverStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelReceiverStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelReceiverStatus_& instance) = 0;

            protected:
                NovatelReceiverStatus_DataReader () {};
                ~NovatelReceiverStatus_DataReader () {};
            private:
                NovatelReceiverStatus_DataReader (const NovatelReceiverStatus_DataReader &);
                NovatelReceiverStatus_DataReader & operator = (const NovatelReceiverStatus_DataReader &);
            };

            class  NovatelReceiverStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelReceiverStatus_DataReaderView_ptr _ptr_type;
                typedef NovatelReceiverStatus_DataReaderView_var _var_type;

                static NovatelReceiverStatus_DataReaderView_ptr _duplicate (NovatelReceiverStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelReceiverStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelReceiverStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelReceiverStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelReceiverStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelReceiverStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelReceiverStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelReceiverStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelReceiverStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelReceiverStatus_& instance) = 0;

            protected:
                NovatelReceiverStatus_DataReaderView () {};
                ~NovatelReceiverStatus_DataReaderView () {};
            private:
                NovatelReceiverStatus_DataReaderView (const NovatelReceiverStatus_DataReaderView &);
                NovatelReceiverStatus_DataReaderView & operator = (const NovatelReceiverStatus_DataReaderView &);
            };
        }

    }

}

#endif
