#ifndef _H_CB5BDE273A3A2F795F89F27EFB9ACA1D_NovatelSignalMask_DCPS_H_
#define _H_CB5BDE273A3A2F795F89F27EFB9ACA1D_NovatelSignalMask_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelSignalMask_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelSignalMask_TypeSupportInterface;

            typedef NovatelSignalMask_TypeSupportInterface * NovatelSignalMask_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelSignalMask_TypeSupportInterface> NovatelSignalMask_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelSignalMask_TypeSupportInterface> NovatelSignalMask_TypeSupportInterface_out;


            class NovatelSignalMask_DataWriter;

            typedef NovatelSignalMask_DataWriter * NovatelSignalMask_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelSignalMask_DataWriter> NovatelSignalMask_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelSignalMask_DataWriter> NovatelSignalMask_DataWriter_out;


            class NovatelSignalMask_DataReader;

            typedef NovatelSignalMask_DataReader * NovatelSignalMask_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelSignalMask_DataReader> NovatelSignalMask_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelSignalMask_DataReader> NovatelSignalMask_DataReader_out;


            class NovatelSignalMask_DataReaderView;

            typedef NovatelSignalMask_DataReaderView * NovatelSignalMask_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelSignalMask_DataReaderView> NovatelSignalMask_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelSignalMask_DataReaderView> NovatelSignalMask_DataReaderView_out;

            struct NovatelSignalMask_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < NovatelSignalMask_, struct NovatelSignalMask_Seq_uniq_> NovatelSignalMask_Seq;
            typedef DDS_DCPSSequence_var < NovatelSignalMask_Seq> NovatelSignalMask_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelSignalMask_Seq> NovatelSignalMask_Seq_out;

            class  NovatelSignalMask_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelSignalMask_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelSignalMask_TypeSupportInterface_var _var_type;

                static NovatelSignalMask_TypeSupportInterface_ptr _duplicate (NovatelSignalMask_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelSignalMask_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelSignalMask_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelSignalMask_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelSignalMask_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelSignalMask_TypeSupportInterface () {};
                ~NovatelSignalMask_TypeSupportInterface () {};
            private:
                NovatelSignalMask_TypeSupportInterface (const NovatelSignalMask_TypeSupportInterface &);
                NovatelSignalMask_TypeSupportInterface & operator = (const NovatelSignalMask_TypeSupportInterface &);
            };

            class  NovatelSignalMask_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelSignalMask_DataWriter_ptr _ptr_type;
                typedef NovatelSignalMask_DataWriter_var _var_type;

                static NovatelSignalMask_DataWriter_ptr _duplicate (NovatelSignalMask_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelSignalMask_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelSignalMask_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelSignalMask_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelSignalMask_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelSignalMask_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelSignalMask_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelSignalMask_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelSignalMask_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelSignalMask_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelSignalMask_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelSignalMask_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelSignalMask_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelSignalMask_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelSignalMask_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelSignalMask_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelSignalMask_& instance_data) = 0;

            protected:
                NovatelSignalMask_DataWriter () {};
                ~NovatelSignalMask_DataWriter () {};
            private:
                NovatelSignalMask_DataWriter (const NovatelSignalMask_DataWriter &);
                NovatelSignalMask_DataWriter & operator = (const NovatelSignalMask_DataWriter &);
            };

            class  NovatelSignalMask_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelSignalMask_DataReader_ptr _ptr_type;
                typedef NovatelSignalMask_DataReader_var _var_type;

                static NovatelSignalMask_DataReader_ptr _duplicate (NovatelSignalMask_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelSignalMask_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelSignalMask_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelSignalMask_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelSignalMask_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelSignalMask_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelSignalMask_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelSignalMask_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelSignalMask_& instance) = 0;

            protected:
                NovatelSignalMask_DataReader () {};
                ~NovatelSignalMask_DataReader () {};
            private:
                NovatelSignalMask_DataReader (const NovatelSignalMask_DataReader &);
                NovatelSignalMask_DataReader & operator = (const NovatelSignalMask_DataReader &);
            };

            class  NovatelSignalMask_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelSignalMask_DataReaderView_ptr _ptr_type;
                typedef NovatelSignalMask_DataReaderView_var _var_type;

                static NovatelSignalMask_DataReaderView_ptr _duplicate (NovatelSignalMask_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelSignalMask_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelSignalMask_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelSignalMask_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelSignalMask_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelSignalMask_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelSignalMask_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelSignalMask_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelSignalMask_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelSignalMask_& instance) = 0;

            protected:
                NovatelSignalMask_DataReaderView () {};
                ~NovatelSignalMask_DataReaderView () {};
            private:
                NovatelSignalMask_DataReaderView (const NovatelSignalMask_DataReaderView &);
                NovatelSignalMask_DataReaderView & operator = (const NovatelSignalMask_DataReaderView &);
            };
        }

    }

}

#endif
