#ifndef _H_78152C732B6AD8D0C282862CFD285278_NovatelUtmPosition__H_
#define _H_78152C732B6AD8D0C282862CFD285278_NovatelUtmPosition__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelMessageHeader_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelExtendedSolutionStatus_.h"
#include "novatel_gps_msgs/msg/dds_opensplice/NovatelSignalMask_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  NovatelUtmPosition_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::novatel_gps_msgs::msg::dds_::NovatelMessageHeader_ novatel_msg_header_;
                ::DDS::String_mgr solution_status_;
                ::DDS::String_mgr position_type_;
                ::DDS::ULong lon_zone_number_;
                ::DDS::String_mgr lat_zone_letter_;
                ::DDS::Double northing_;
                ::DDS::Double easting_;
                ::DDS::Double height_;
                ::DDS::Float undulation_;
                ::DDS::String_mgr datum_id_;
                ::DDS::Float northing_sigma_;
                ::DDS::Float easting_sigma_;
                ::DDS::Float height_sigma_;
                ::DDS::String_mgr base_station_id_;
                ::DDS::Float diff_age_;
                ::DDS::Float solution_age_;
                ::DDS::Octet num_satellites_tracked_;
                ::DDS::Octet num_satellites_used_in_solution_;
                ::DDS::Octet num_gps_and_glonass_l1_used_in_solution_;
                ::DDS::Octet num_gps_and_glonass_l1_and_l2_used_in_solution_;
                ::novatel_gps_msgs::msg::dds_::NovatelExtendedSolutionStatus_ extended_solution_status_;
                ::novatel_gps_msgs::msg::dds_::NovatelSignalMask_ signal_mask_;
            };

            typedef DDS_DCPSStruct_var<NovatelUtmPosition_> NovatelUtmPosition__var;
            typedef DDS_DCPSStruct_out < NovatelUtmPosition_> NovatelUtmPosition__out;

        }

    }

}

#endif /* _H_78152C732B6AD8D0C282862CFD285278_NovatelUtmPosition__H_ */
