#ifndef _H_78152C732B6AD8D0C282862CFD285278_NovatelUtmPosition_DCPS_H_
#define _H_78152C732B6AD8D0C282862CFD285278_NovatelUtmPosition_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "NovatelUtmPosition_.h"


namespace novatel_gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class NovatelUtmPosition_TypeSupportInterface;

            typedef NovatelUtmPosition_TypeSupportInterface * NovatelUtmPosition_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < NovatelUtmPosition_TypeSupportInterface> NovatelUtmPosition_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < NovatelUtmPosition_TypeSupportInterface> NovatelUtmPosition_TypeSupportInterface_out;


            class NovatelUtmPosition_DataWriter;

            typedef NovatelUtmPosition_DataWriter * NovatelUtmPosition_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < NovatelUtmPosition_DataWriter> NovatelUtmPosition_DataWriter_var;
            typedef DDS_DCPSInterface_out < NovatelUtmPosition_DataWriter> NovatelUtmPosition_DataWriter_out;


            class NovatelUtmPosition_DataReader;

            typedef NovatelUtmPosition_DataReader * NovatelUtmPosition_DataReader_ptr;
            typedef DDS_DCPSInterface_var < NovatelUtmPosition_DataReader> NovatelUtmPosition_DataReader_var;
            typedef DDS_DCPSInterface_out < NovatelUtmPosition_DataReader> NovatelUtmPosition_DataReader_out;


            class NovatelUtmPosition_DataReaderView;

            typedef NovatelUtmPosition_DataReaderView * NovatelUtmPosition_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < NovatelUtmPosition_DataReaderView> NovatelUtmPosition_DataReaderView_var;
            typedef DDS_DCPSInterface_out < NovatelUtmPosition_DataReaderView> NovatelUtmPosition_DataReaderView_out;

            struct NovatelUtmPosition_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < NovatelUtmPosition_, struct NovatelUtmPosition_Seq_uniq_> NovatelUtmPosition_Seq;
            typedef DDS_DCPSSequence_var < NovatelUtmPosition_Seq> NovatelUtmPosition_Seq_var;
            typedef DDS_DCPSSequence_out < NovatelUtmPosition_Seq> NovatelUtmPosition_Seq_out;

            class  NovatelUtmPosition_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef NovatelUtmPosition_TypeSupportInterface_ptr _ptr_type;
                typedef NovatelUtmPosition_TypeSupportInterface_var _var_type;

                static NovatelUtmPosition_TypeSupportInterface_ptr _duplicate (NovatelUtmPosition_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelUtmPosition_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static NovatelUtmPosition_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelUtmPosition_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelUtmPosition_TypeSupportInterface_ptr _this () { return this; }


            protected:
                NovatelUtmPosition_TypeSupportInterface () {};
                ~NovatelUtmPosition_TypeSupportInterface () {};
            private:
                NovatelUtmPosition_TypeSupportInterface (const NovatelUtmPosition_TypeSupportInterface &);
                NovatelUtmPosition_TypeSupportInterface & operator = (const NovatelUtmPosition_TypeSupportInterface &);
            };

            class  NovatelUtmPosition_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef NovatelUtmPosition_DataWriter_ptr _ptr_type;
                typedef NovatelUtmPosition_DataWriter_var _var_type;

                static NovatelUtmPosition_DataWriter_ptr _duplicate (NovatelUtmPosition_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelUtmPosition_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static NovatelUtmPosition_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelUtmPosition_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelUtmPosition_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const NovatelUtmPosition_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const NovatelUtmPosition_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const NovatelUtmPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const NovatelUtmPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const NovatelUtmPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const NovatelUtmPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const NovatelUtmPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const NovatelUtmPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const NovatelUtmPosition_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const NovatelUtmPosition_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (NovatelUtmPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelUtmPosition_& instance_data) = 0;

            protected:
                NovatelUtmPosition_DataWriter () {};
                ~NovatelUtmPosition_DataWriter () {};
            private:
                NovatelUtmPosition_DataWriter (const NovatelUtmPosition_DataWriter &);
                NovatelUtmPosition_DataWriter & operator = (const NovatelUtmPosition_DataWriter &);
            };

            class  NovatelUtmPosition_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef NovatelUtmPosition_DataReader_ptr _ptr_type;
                typedef NovatelUtmPosition_DataReader_var _var_type;

                static NovatelUtmPosition_DataReader_ptr _duplicate (NovatelUtmPosition_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelUtmPosition_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static NovatelUtmPosition_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelUtmPosition_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelUtmPosition_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelUtmPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelUtmPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelUtmPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelUtmPosition_& instance) = 0;

            protected:
                NovatelUtmPosition_DataReader () {};
                ~NovatelUtmPosition_DataReader () {};
            private:
                NovatelUtmPosition_DataReader (const NovatelUtmPosition_DataReader &);
                NovatelUtmPosition_DataReader & operator = (const NovatelUtmPosition_DataReader &);
            };

            class  NovatelUtmPosition_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef NovatelUtmPosition_DataReaderView_ptr _ptr_type;
                typedef NovatelUtmPosition_DataReaderView_var _var_type;

                static NovatelUtmPosition_DataReaderView_ptr _duplicate (NovatelUtmPosition_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static NovatelUtmPosition_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static NovatelUtmPosition_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static NovatelUtmPosition_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                NovatelUtmPosition_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (NovatelUtmPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (NovatelUtmPosition_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (NovatelUtmPosition_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (NovatelUtmPosition_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const NovatelUtmPosition_& instance) = 0;

            protected:
                NovatelUtmPosition_DataReaderView () {};
                ~NovatelUtmPosition_DataReaderView () {};
            private:
                NovatelUtmPosition_DataReaderView (const NovatelUtmPosition_DataReaderView &);
                NovatelUtmPosition_DataReaderView & operator = (const NovatelUtmPosition_DataReaderView &);
            };
        }

    }

}

#endif
