// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/Gpgsa.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/gpgsa__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `message_id`
// Member `auto_manual_mode`
#include "rosidl_generator_c/string_functions.h"
// Member `sv_ids`
#include "rosidl_generator_c/primitives_sequence_functions.h"

bool
novatel_gps_msgs__msg__Gpgsa__init(novatel_gps_msgs__msg__Gpgsa * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__Gpgsa__fini(msg);
    return false;
  }
  // message_id
  if (!rosidl_generator_c__String__init(&msg->message_id)) {
    novatel_gps_msgs__msg__Gpgsa__fini(msg);
    return false;
  }
  // auto_manual_mode
  if (!rosidl_generator_c__String__init(&msg->auto_manual_mode)) {
    novatel_gps_msgs__msg__Gpgsa__fini(msg);
    return false;
  }
  // fix_mode
  // sv_ids
  if (!rosidl_generator_c__uint8__Sequence__init(&msg->sv_ids, 0)) {
    novatel_gps_msgs__msg__Gpgsa__fini(msg);
    return false;
  }
  // pdop
  // hdop
  // vdop
  return true;
}

void
novatel_gps_msgs__msg__Gpgsa__fini(novatel_gps_msgs__msg__Gpgsa * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // message_id
  rosidl_generator_c__String__fini(&msg->message_id);
  // auto_manual_mode
  rosidl_generator_c__String__fini(&msg->auto_manual_mode);
  // fix_mode
  // sv_ids
  rosidl_generator_c__uint8__Sequence__fini(&msg->sv_ids);
  // pdop
  // hdop
  // vdop
}

novatel_gps_msgs__msg__Gpgsa *
novatel_gps_msgs__msg__Gpgsa__create()
{
  novatel_gps_msgs__msg__Gpgsa * msg = (novatel_gps_msgs__msg__Gpgsa *)malloc(sizeof(novatel_gps_msgs__msg__Gpgsa));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__Gpgsa));
  bool success = novatel_gps_msgs__msg__Gpgsa__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__Gpgsa__destroy(novatel_gps_msgs__msg__Gpgsa * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__Gpgsa__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__Gpgsa__Sequence__init(novatel_gps_msgs__msg__Gpgsa__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__Gpgsa * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__Gpgsa *)calloc(size, sizeof(novatel_gps_msgs__msg__Gpgsa));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__Gpgsa__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__Gpgsa__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__Gpgsa__Sequence__fini(novatel_gps_msgs__msg__Gpgsa__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__Gpgsa__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__Gpgsa__Sequence *
novatel_gps_msgs__msg__Gpgsa__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__Gpgsa__Sequence * array = (novatel_gps_msgs__msg__Gpgsa__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__Gpgsa__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__Gpgsa__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__Gpgsa__Sequence__destroy(novatel_gps_msgs__msg__Gpgsa__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__Gpgsa__Sequence__fini(array);
  }
  free(array);
}
