// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from novatel_gps_msgs:msg/NovatelReceiverStatus.idl
// generated code does not contain a copyright notice

#ifndef NOVATEL_GPS_MSGS__MSG__NOVATEL_RECEIVER_STATUS__STRUCT_H_
#define NOVATEL_GPS_MSGS__MSG__NOVATEL_RECEIVER_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Struct defined in msg/NovatelReceiverStatus in the package novatel_gps_msgs.
typedef struct novatel_gps_msgs__msg__NovatelReceiverStatus
{
  uint32_t original_status_code;
  bool error_flag;
  bool temperature_flag;
  bool voltage_supply_flag;
  bool antenna_powered;
  bool antenna_is_open;
  bool antenna_is_shorted;
  bool cpu_overload_flag;
  bool com1_buffer_overrun;
  bool com2_buffer_overrun;
  bool com3_buffer_overrun;
  bool usb_buffer_overrun;
  bool rf1_agc_flag;
  bool rf2_agc_flag;
  bool almanac_flag;
  bool position_solution_flag;
  bool position_fixed_flag;
  bool clock_steering_status_enabled;
  bool clock_model_flag;
  bool oemv_external_oscillator_flag;
  bool software_resource_flag;
  bool aux1_status_event_flag;
  bool aux2_status_event_flag;
  bool aux3_status_event_flag;
} novatel_gps_msgs__msg__NovatelReceiverStatus;

// Struct for a sequence of novatel_gps_msgs__msg__NovatelReceiverStatus.
typedef struct novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence
{
  novatel_gps_msgs__msg__NovatelReceiverStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NOVATEL_GPS_MSGS__MSG__NOVATEL_RECEIVER_STATUS__STRUCT_H_
