// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/Trackstat.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/trackstat__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `solution_status`
// Member `position_type`
#include "rosidl_generator_c/string_functions.h"
// Member `channels`
#include "novatel_gps_msgs/msg/trackstat_channel__functions.h"

bool
novatel_gps_msgs__msg__Trackstat__init(novatel_gps_msgs__msg__Trackstat * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__Trackstat__fini(msg);
    return false;
  }
  // solution_status
  if (!rosidl_generator_c__String__init(&msg->solution_status)) {
    novatel_gps_msgs__msg__Trackstat__fini(msg);
    return false;
  }
  // position_type
  if (!rosidl_generator_c__String__init(&msg->position_type)) {
    novatel_gps_msgs__msg__Trackstat__fini(msg);
    return false;
  }
  // cutoff
  // channels
  if (!novatel_gps_msgs__msg__TrackstatChannel__Sequence__init(&msg->channels, 0)) {
    novatel_gps_msgs__msg__Trackstat__fini(msg);
    return false;
  }
  return true;
}

void
novatel_gps_msgs__msg__Trackstat__fini(novatel_gps_msgs__msg__Trackstat * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // solution_status
  rosidl_generator_c__String__fini(&msg->solution_status);
  // position_type
  rosidl_generator_c__String__fini(&msg->position_type);
  // cutoff
  // channels
  novatel_gps_msgs__msg__TrackstatChannel__Sequence__fini(&msg->channels);
}

novatel_gps_msgs__msg__Trackstat *
novatel_gps_msgs__msg__Trackstat__create()
{
  novatel_gps_msgs__msg__Trackstat * msg = (novatel_gps_msgs__msg__Trackstat *)malloc(sizeof(novatel_gps_msgs__msg__Trackstat));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__Trackstat));
  bool success = novatel_gps_msgs__msg__Trackstat__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__Trackstat__destroy(novatel_gps_msgs__msg__Trackstat * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__Trackstat__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__Trackstat__Sequence__init(novatel_gps_msgs__msg__Trackstat__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__Trackstat * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__Trackstat *)calloc(size, sizeof(novatel_gps_msgs__msg__Trackstat));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__Trackstat__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__Trackstat__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__Trackstat__Sequence__fini(novatel_gps_msgs__msg__Trackstat__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__Trackstat__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__Trackstat__Sequence *
novatel_gps_msgs__msg__Trackstat__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__Trackstat__Sequence * array = (novatel_gps_msgs__msg__Trackstat__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__Trackstat__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__Trackstat__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__Trackstat__Sequence__destroy(novatel_gps_msgs__msg__Trackstat__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__Trackstat__Sequence__fini(array);
  }
  free(array);
}
