#ifndef _H_B23E4BAEA991AD8CAD8799B58CB95304_NovatelFRESET__H_
#define _H_B23E4BAEA991AD8CAD8799B58CB95304_NovatelFRESET__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace novatel_gps_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  NovatelFRESET_Request_
            {
                ::DDS::String_mgr target_;
            };

            typedef DDS_DCPSStruct_var<NovatelFRESET_Request_> NovatelFRESET_Request__var;
            typedef DDS_DCPSStruct_out < NovatelFRESET_Request_> NovatelFRESET_Request__out;

            struct  NovatelFRESET_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<NovatelFRESET_Response_> NovatelFRESET_Response__var;
            typedef NovatelFRESET_Response_& NovatelFRESET_Response__out;

            struct  Sample_NovatelFRESET_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::novatel_gps_msgs::srv::dds_::NovatelFRESET_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_NovatelFRESET_Request_> Sample_NovatelFRESET_Request__var;
            typedef DDS_DCPSStruct_out < Sample_NovatelFRESET_Request_> Sample_NovatelFRESET_Request__out;

            struct  Sample_NovatelFRESET_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::novatel_gps_msgs::srv::dds_::NovatelFRESET_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_NovatelFRESET_Response_> Sample_NovatelFRESET_Response__var;
            typedef Sample_NovatelFRESET_Response_& Sample_NovatelFRESET_Response__out;

        }

    }

}

#endif /* _H_B23E4BAEA991AD8CAD8799B58CB95304_NovatelFRESET__H_ */
